Require Import ssreflect.
Require Import ssrfun.
Require Import ssrbool.

Require Import Utf8.
Require Import Setoid.
Require Import Morphisms.

Require Import LibTactics.
Require Import DomType.
Require Import DomBasic.
Require Import DomBridge.

Require Import DomAbsValue.
Require Import DomSet.
Require Import DomMap.
Require Import DomAcc.
Require Import DomAbsMem.

Require Import Syntax.

Set Implicit Arguments.

Definition func_stateT := Map![bidT * bool, memT].
Global Instance func_stateT_setoid : setoid func_stateT := _.
Global Instance func_stateT_setoidDec : @setoidDec func_stateT _ := _.
Global Instance func_stateT_poset : @poset func_stateT _ := _.
Global Instance func_stateT_posetDec : @posetDec func_stateT _ _ _ := _. 
Global Instance func_stateT_hasJoin : @hasJoin func_stateT _ _ := _.
Global Instance func_stateT_maplike : maplike (Key:=bidT*bool) (Elt:=memT) (M:=func_stateT) := _.

Definition stateT' := Map![fidT, func_stateT].
Global Instance stateT'_setoid : setoid stateT' := _.
Global Instance stateT'_setoidDec : @setoidDec stateT' _ := _.
Global Instance stateT'_poset : @poset stateT' _ := _.
Global Instance stateT'_posetDec : @posetDec stateT' _ _ _ := _. 
Global Instance stateT'_hasJoin : @hasJoin stateT' _ _ := _.
Global Instance stateT'_maplike : maplike (Key:=fidT) (Elt:=func_stateT) (M:=stateT') := _.
