let rec is_prefix s pre = 
  let s_len = String.length s in
  let pre_len = String.length pre in
  if pre_len = 0 
  then true
  else if s_len < pre_len
  then false
  else 
    let s_head = String.get s 0 in
    let s_tail = String.sub s 1 (s_len-1) in
    let pre_head = String.get pre 0 in
    let pre_tail = String.sub pre 1 (pre_len-1) in
    if s_head = pre_head
    then is_prefix s_tail pre_tail
    else false

let rec exists s sub = 
  let s_len = String.length s in
  if s_len = 0
  then false
  else if is_prefix s sub
  then true
  else exists (String.sub s 1 (s_len-1)) sub

let rec str_first_n s sub n = 
  if is_prefix s sub
  then n
  else str_first_n (String.sub s 1 ((String.length s)-1)) sub (n+1)

let str_first s sub = str_first_n s sub 0

let split s sep = 
  let i = str_first s sep in
  let s_length = String.length s in
  let sep_length = String.length sep in
  (String.sub s 0 i, String.sub s (i+sep_length) (s_length-(i+sep_length)))

let rec splits s sep = 
  if exists s sep
  then 
    let (a,b) = split s sep in
    a::(splits b sep)
  else [s]
