open DomAbsMem
open DomAbsValue
open DomBasic
open DomMap
open DomType
open MapInterface

type func_stateT = (bidT * bool, memT) dict

(** val func_stateT_poset : func_stateT poset **)

let func_stateT_poset =
  map_poset (pair_setoid positive_setoid bool_setoid)
    (pair_poset positive_setoid bool_setoid positive_poset bool_poset)
    (pair_setoidDec positive_setoid bool_setoid positive_setoidDec
      bool_setoidDec)
    (pair_posetDec positive_setoid bool_setoid positive_poset bool_poset
      positive_setoidDec bool_setoidDec positive_posetDec bool_posetDec)
    (withtop_setoid
      (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot))
    (withtop_poset
      (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot)
      (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot))
    (withtop_hasBot
      (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot)
      (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot)
      (map_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot))

(** val func_stateT_maplike : (bidT * bool, memT, func_stateT) maplike **)

let func_stateT_maplike =
  map_maplike (pair_setoid positive_setoid bool_setoid)
    (pair_poset positive_setoid bool_setoid positive_poset bool_poset)
    (pair_setoidDec positive_setoid bool_setoid positive_setoidDec
      bool_setoidDec)
    (pair_posetDec positive_setoid bool_setoid positive_poset bool_poset
      positive_setoidDec bool_setoidDec positive_posetDec bool_posetDec)
    (withtop_setoid
      (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot)) memT_poset
    (withtop_hasBot
      (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot)
      (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot)
      (map_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec
        valueT_setoid valueT_poset valueT_hasBot))

type stateT' = (fidT, func_stateT) dict

(** val stateT'_maplike : (fidT, func_stateT, stateT') maplike **)

let stateT'_maplike =
  map_maplike positive_setoid positive_poset positive_setoidDec
    positive_posetDec
    (map_setoid (pair_setoid positive_setoid bool_setoid)
      (pair_poset positive_setoid bool_setoid positive_poset bool_poset)
      (pair_setoidDec positive_setoid bool_setoid positive_setoidDec
        bool_setoidDec)
      (pair_posetDec positive_setoid bool_setoid positive_poset bool_poset
        positive_setoidDec bool_setoidDec positive_posetDec bool_posetDec)
      memT_setoid memT_poset
      (withtop_hasBot
        (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
          valueT_setoid valueT_poset valueT_hasBot)
        (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
          valueT_setoid valueT_poset valueT_hasBot)
        (map_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec
          valueT_setoid valueT_poset valueT_hasBot))) func_stateT_poset
    (map_hasBot (pair_setoid positive_setoid bool_setoid)
      (pair_poset positive_setoid bool_setoid positive_poset bool_poset)
      (pair_setoidDec positive_setoid bool_setoid positive_setoidDec
        bool_setoidDec)
      (pair_posetDec positive_setoid bool_setoid positive_poset bool_poset
        positive_setoidDec bool_setoidDec positive_posetDec bool_posetDec)
      memT_setoid memT_poset
      (withtop_hasBot
        (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
          valueT_setoid valueT_poset valueT_hasBot)
        (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
          valueT_setoid valueT_poset valueT_hasBot)
        (map_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec
          valueT_setoid valueT_poset valueT_hasBot)))

