open BinPos
open Datatypes
open DomType
open Ssrbool

type ('a, 'b) morphism = ('a -> 'b)

type 'a powerset = ('a, bool) morphism

(** val powerset_setlike :
    'a1 setoid -> 'a1 setoidDec -> ('a1, 'a1 powerset) setlike **)

let powerset_setlike h h0 =
  { sempty = (fun x -> false); ssingleton = (fun elt elt' ->
    eqb h h0 elt elt'); smem = (fun elt s -> s elt); sadd =
    (fun elt s elt' -> if eqb h h0 elt elt' then true else s elt'); sremove =
    (fun elt s elt' -> if eqb h h0 elt elt' then false else s elt') }

(** val powerset_neg : 'a1 setoid -> 'a1 powerset -> 'a1 powerset **)

let powerset_neg h s x =
  negb (s x)

type ('k, 'e, 'm) restricting_maplike =
  'k powerset -> 'm -> 'm
  (* singleton inductive, whose constructor was RestrictingMaplike *)

(** val mrestrict :
    'a1 setoid -> 'a1 setoidDec -> 'a2 setoid -> 'a2 poset -> 'a3 setoid ->
    'a3 poset -> 'a3 hasBot -> ('a1, 'a2, 'a3) maplike -> ('a1, 'a2, 'a3)
    restricting_maplike -> 'a1 powerset -> 'a3 -> 'a3 **)

let mrestrict h h0 h1 h2 h3 h4 h5 h6 restricting_maplike0 =
  restricting_maplike0

(** val option_setoid : 'a1 setoid -> 'a1 option setoid **)

let option_setoid h =
  Setoid

(** val option_poset : 'a1 setoid -> 'a1 poset -> 'a1 option poset **)

let option_poset h h0 =
  Poset

(** val option_hasBot : 'a1 setoid -> 'a1 poset -> 'a1 option hasBot **)

let option_hasBot h h0 =
  None

(** val option_hasTop :
    'a1 setoid -> 'a1 poset -> 'a1 hasTop -> 'a1 option hasTop **)

let option_hasTop h h0 h1 =
  Some (top h h0 h1)

(** val option_join :
    'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 option -> 'a1 option -> 'a1
    option **)

let option_join h h0 h1 x y =
  match x with
  | Some x' ->
    (match y with
     | Some y' -> Some (join h h0 h1 x' y')
     | None -> x)
  | None -> y

(** val option_hasJoin :
    'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 option hasJoin **)

let option_hasJoin h h0 h1 =
  option_join h h0 h1

(** val option_eqb :
    'a1 setoid -> 'a1 setoidDec -> 'a1 option -> 'a1 option -> bool **)

let option_eqb h h1 x y =
  match x with
  | Some x' ->
    (match y with
     | Some y' -> eqb h h1 x' y'
     | None -> false)
  | None ->
    (match y with
     | Some y0 -> false
     | None -> true)

(** val option_setoidDec_obligation_1 :
    'a1 setoid -> 'a1 setoidDec -> 'a1 option -> 'a1 option -> reflect **)

let option_setoidDec_obligation_1 h h1 x y =
  let _evar_0_ = fun x0 _top_assumption_ ->
    let _evar_0_ = fun y0 -> eqbP h h1 x0 y0 in
    let _evar_0_0 = ReflectF in
    (match _top_assumption_ with
     | Some x1 -> _evar_0_ x1
     | None -> _evar_0_0)
  in
  let _evar_0_0 = fun _top_assumption_ ->
    let _evar_0_0 = fun y0 -> ReflectF in
    let _evar_0_1 = ReflectT in
    (match _top_assumption_ with
     | Some x0 -> _evar_0_0 x0
     | None -> _evar_0_1)
  in
  (match x with
   | Some x0 -> _evar_0_ x0 y
   | None -> _evar_0_0 y)

(** val option_setoidDec :
    'a1 setoid -> 'a1 setoidDec -> 'a1 option setoidDec **)

let option_setoidDec h h1 =
  { eqb_ = (option_eqb h h1); eqbP_ = (option_setoidDec_obligation_1 h h1) }

(** val option_leb :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 option ->
    'a1 option -> bool **)

let option_leb h h0 h1 h2 x y =
  match x with
  | Some x' ->
    (match y with
     | Some y' -> leb h h0 h1 h2 x' y'
     | None -> false)
  | None -> true

(** val option_posetDec_obligation_1 :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 option ->
    'a1 option -> reflect **)

let option_posetDec_obligation_1 h h0 h1 h2 x y =
  let _evar_0_ = fun x0 _top_assumption_ ->
    let _evar_0_ = fun y0 -> lebP h h0 h1 h2 x0 y0 in
    let _evar_0_0 = ReflectF in
    (match _top_assumption_ with
     | Some x1 -> _evar_0_ x1
     | None -> _evar_0_0)
  in
  let _evar_0_0 = fun _top_assumption_ ->
    let _evar_0_0 = fun y0 -> ReflectT in
    let _evar_0_1 = ReflectT in
    (match _top_assumption_ with
     | Some x0 -> _evar_0_0 x0
     | None -> _evar_0_1)
  in
  (match x with
   | Some x0 -> _evar_0_ x0 y
   | None -> _evar_0_0 y)

(** val option_posetDec :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 option
    posetDec **)

let option_posetDec h h0 h1 h2 =
  { leb_ = (option_leb h h0 h1 h2); lebP_ =
    (option_posetDec_obligation_1 h h0 h1 h2) }

type 'a withtop =
| Elt of 'a
| Top

(** val withtop_setoid : 'a1 setoid -> 'a1 withtop setoid **)

let withtop_setoid h =
  Setoid

(** val withtop_poset : 'a1 setoid -> 'a1 poset -> 'a1 withtop poset **)

let withtop_poset h h0 =
  Poset

(** val withtop_hasBot :
    'a1 setoid -> 'a1 poset -> 'a1 hasBot -> 'a1 withtop hasBot **)

let withtop_hasBot h h0 h1 =
  Elt (bot h h0 h1)

(** val withtop_hasTop : 'a1 setoid -> 'a1 poset -> 'a1 withtop hasTop **)

let withtop_hasTop h h0 =
  Top

(** val withtop_join :
    'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 withtop -> 'a1 withtop ->
    'a1 withtop **)

let withtop_join h h0 h1 x y =
  match x with
  | Elt x' ->
    (match y with
     | Elt y' -> Elt (join h h0 h1 x' y')
     | Top -> Top)
  | Top -> Top

(** val withtop_hasJoin :
    'a1 setoid -> 'a1 poset -> 'a1 hasJoin -> 'a1 withtop hasJoin **)

let withtop_hasJoin h h0 h1 =
  withtop_join h h0 h1

(** val withtop_eqb :
    'a1 setoid -> 'a1 setoidDec -> 'a1 withtop -> 'a1 withtop -> bool **)

let withtop_eqb h h1 x y =
  match x with
  | Elt x' ->
    (match y with
     | Elt y' -> eqb h h1 x' y'
     | Top -> false)
  | Top ->
    (match y with
     | Elt y0 -> false
     | Top -> true)

(** val withtop_setoidDec_obligation_1 :
    'a1 setoid -> 'a1 setoidDec -> 'a1 withtop -> 'a1 withtop -> reflect **)

let withtop_setoidDec_obligation_1 h h1 x y =
  let _evar_0_ = fun x0 _top_assumption_ ->
    let _evar_0_ = fun y0 -> eqbP h h1 x0 y0 in
    let _evar_0_0 = ReflectF in
    (match _top_assumption_ with
     | Elt x1 -> _evar_0_ x1
     | Top -> _evar_0_0)
  in
  let _evar_0_0 = fun _top_assumption_ ->
    let _evar_0_0 = fun y0 -> ReflectF in
    let _evar_0_1 = ReflectT in
    (match _top_assumption_ with
     | Elt x0 -> _evar_0_0 x0
     | Top -> _evar_0_1)
  in
  (match x with
   | Elt x0 -> _evar_0_ x0 y
   | Top -> _evar_0_0 y)

(** val withtop_setoidDec :
    'a1 setoid -> 'a1 setoidDec -> 'a1 withtop setoidDec **)

let withtop_setoidDec h h1 =
  { eqb_ = (withtop_eqb h h1); eqbP_ =
    (withtop_setoidDec_obligation_1 h h1) }

(** val withtop_leb :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 withtop
    -> 'a1 withtop -> bool **)

let withtop_leb h h0 h1 h2 x y =
  match x with
  | Elt x' ->
    (match y with
     | Elt y' -> leb h h0 h1 h2 x' y'
     | Top -> true)
  | Top ->
    (match y with
     | Elt y0 -> false
     | Top -> true)

(** val withtop_posetDec_obligation_1 :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 withtop
    -> 'a1 withtop -> reflect **)

let withtop_posetDec_obligation_1 h h0 h1 h2 x y =
  let _evar_0_ = fun x0 _top_assumption_ ->
    let _evar_0_ = fun y0 -> lebP h h0 h1 h2 x0 y0 in
    let _evar_0_0 = ReflectT in
    (match _top_assumption_ with
     | Elt x1 -> _evar_0_ x1
     | Top -> _evar_0_0)
  in
  let _evar_0_0 = fun _top_assumption_ ->
    let _evar_0_0 = fun y0 -> ReflectF in
    let _evar_0_1 = ReflectT in
    (match _top_assumption_ with
     | Elt x0 -> _evar_0_0 x0
     | Top -> _evar_0_1)
  in
  (match x with
   | Elt x0 -> _evar_0_ x0 y
   | Top -> _evar_0_0 y)

(** val withtop_posetDec :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 withtop
    posetDec **)

let withtop_posetDec h h0 h1 h2 =
  { leb_ = (withtop_leb h h0 h1 h2); lebP_ =
    (withtop_posetDec_obligation_1 h h0 h1 h2) }

(** val withtop_maplike :
    'a1 setoid -> 'a1 poset -> 'a2 setoid -> 'a2 setoidDec -> 'a3 setoid ->
    'a3 poset -> 'a3 hasTop -> ('a2, 'a3, 'a1) maplike -> ('a2, 'a3, 'a1
    withtop) maplike **)

let withtop_maplike h h0 h1 h2 h3 h4 h5 h6 =
  { mlookup = (fun k m ->
    match m with
    | Elt m' -> h6.mlookup k m'
    | Top -> top h3 h4 h5); madd = (fun k e m ->
    match m with
    | Elt m' -> Elt (h6.madd k e m')
    | Top -> Top); mremove = (fun k m ->
    match m with
    | Elt m' -> Elt (h6.mremove k m')
    | Top -> Top) }

(** val withtop_restricting_maplike :
    'a1 setoid -> 'a1 poset -> 'a2 setoid -> 'a2 setoidDec -> 'a3 setoid ->
    'a3 poset -> 'a3 hasTop -> 'a1 hasBot -> ('a2, 'a3, 'a1) maplike -> ('a2,
    'a3, 'a1) restricting_maplike -> ('a2, 'a3, 'a1 withtop)
    restricting_maplike **)

let withtop_restricting_maplike h h0 h1 h2 h3 h4 h5 h6 h7 h8 s = function
| Elt m' -> Elt (mrestrict h1 h2 h3 h4 h h0 h6 h7 h8 s m')
| Top -> Top

(** val pair_setoid : 'a1 setoid -> 'a2 setoid -> ('a1 * 'a2) setoid **)

let pair_setoid h h0 =
  Setoid

(** val pair_poset :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> ('a1 * 'a2) poset **)

let pair_poset h h0 h1 h2 =
  Poset

(** val pair_eqb :
    'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1 * 'a2)
    -> ('a1 * 'a2) -> bool **)

let pair_eqb h h0 h3 h4 x y =
  (&&) (eqb h h3 (fst x) (fst y)) (eqb h0 h4 (snd x) (snd y))

(** val pair_setoidDec_obligation_1 :
    'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1 * 'a2)
    -> ('a1 * 'a2) -> reflect **)

let pair_setoidDec_obligation_1 h h0 h3 h4 x = function
| (a, b) ->
  let (a0, b0) = x in
  let _evar_0_ = andP (eqb h h3 a0 a) (eqb h0 h4 b0 b) in
  equivP ((&&) (eqb h h3 a0 a) (eqb h0 h4 b0 b)) _evar_0_

(** val pair_setoidDec :
    'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1 * 'a2)
    setoidDec **)

let pair_setoidDec h h0 h3 h4 =
  { eqb_ = (pair_eqb h h0 h3 h4); eqbP_ =
    (pair_setoidDec_obligation_1 h h0 h3 h4) }

(** val pair_leb :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec ->
    'a2 setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) ->
    ('a1 * 'a2) -> bool **)

let pair_leb h h0 h1 h2 h3 h4 h5 h6 x y =
  (||) (ltb h h1 h3 h5 (fst x) (fst y))
    ((&&) (eqb h h3 (fst x) (fst y)) (leb h0 h2 h4 h6 (snd x) (snd y)))

(** val pair_posetDec_obligation_1 :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec ->
    'a2 setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) ->
    ('a1 * 'a2) -> reflect **)

let pair_posetDec_obligation_1 h h0 h1 h2 h3 h4 h5 h6 x = function
| (a, b) ->
  let (a0, b0) = x in
  let _evar_0_ =
    orP (ltb h h1 h3 h5 a0 a) ((&&) (eqb h h3 a0 a) (leb h0 h2 h4 h6 b0 b))
  in
  equivP
    ((||) (ltb h h1 h3 h5 a0 a)
      ((&&) (eqb h h3 a0 a) (leb h0 h2 h4 h6 b0 b))) _evar_0_

(** val pair_posetDec :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec ->
    'a2 setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) posetDec **)

let pair_posetDec h h0 h1 h2 h3 h4 h5 h6 =
  { leb_ = (pair_leb h h0 h1 h2 h3 h4 h5 h6); lebP_ =
    (pair_posetDec_obligation_1 h h0 h1 h2 h3 h4 h5 h6) }

(** val pair_poset_pointwise :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> ('a1 * 'a2) poset **)

let pair_poset_pointwise h h0 h1 h2 =
  Poset

(** val pair_hasBot_pointwise :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 hasBot -> 'a2
    hasBot -> ('a1 * 'a2) hasBot **)

let pair_hasBot_pointwise h h0 h1 h2 h3 h4 =
  ((bot h h1 h3), (bot h0 h2 h4))

(** val pair_hasTop_pointwise :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 hasTop -> 'a2
    hasTop -> ('a1 * 'a2) hasTop **)

let pair_hasTop_pointwise h h0 h1 h2 h3 h4 =
  ((top h h1 h3), (top h0 h2 h4))

(** val pair_hasJoin_pointwise :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 hasJoin -> 'a2
    hasJoin -> ('a1 * 'a2) hasJoin **)

let pair_hasJoin_pointwise h h0 h1 h2 h3 h4 x y =
  ((join h h1 h3 (fst x) (fst y)), (join h0 h2 h4 (snd x) (snd y)))

(** val pair_posetDec_pointwise_obligation_1 :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec ->
    'a2 setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) ->
    ('a1 * 'a2) -> reflect **)

let pair_posetDec_pointwise_obligation_1 h h0 h1 h2 h3 h4 h5 h6 x y =
  let _evar_0_ =
    andP (leb h h1 h3 h5 (fst x) (fst y)) (leb h0 h2 h4 h6 (snd x) (snd y))
  in
  equivP
    ((&&) (leb h h1 h3 h5 (fst x) (fst y)) (leb h0 h2 h4 h6 (snd x) (snd y)))
    _evar_0_

(** val pair_posetDec_pointwise :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec ->
    'a2 setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1 * 'a2) posetDec **)

let pair_posetDec_pointwise h h0 h1 h2 h3 h4 h5 h6 =
  { leb_ = (fun x y ->
    (&&) (leb h h1 h3 h5 (fst x) (fst y)) (leb h0 h2 h4 h6 (snd x) (snd y)));
    lebP_ = (pair_posetDec_pointwise_obligation_1 h h0 h1 h2 h3 h4 h5 h6) }

(** val sum_setoid : 'a1 setoid -> 'a2 setoid -> ('a1, 'a2) sum setoid **)

let sum_setoid h h0 =
  Setoid

(** val sum_poset :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> ('a1, 'a2) sum
    poset **)

let sum_poset h h0 h1 h2 =
  Poset

(** val sum_eqb :
    'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1, 'a2)
    sum -> ('a1, 'a2) sum -> bool **)

let sum_eqb h h0 h3 h4 x y =
  match x with
  | Coq_inl x' ->
    (match y with
     | Coq_inl y' -> eqb h h3 x' y'
     | Coq_inr b -> false)
  | Coq_inr x' ->
    (match y with
     | Coq_inl a -> false
     | Coq_inr y' -> eqb h0 h4 x' y')

(** val sum_setoidDec_obligation_1 :
    'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1, 'a2)
    sum -> ('a1, 'a2) sum -> reflect **)

let sum_setoidDec_obligation_1 h h0 h3 h4 x y =
  let _evar_0_ = fun x0 _top_assumption_ ->
    let _evar_0_ = fun z -> eqbP h h3 x0 z in
    let _evar_0_0 = fun w -> ReflectF in
    (match _top_assumption_ with
     | Coq_inl x1 -> _evar_0_ x1
     | Coq_inr x1 -> _evar_0_0 x1)
  in
  let _evar_0_0 = fun y0 _top_assumption_ ->
    let _evar_0_0 = fun z -> ReflectF in
    let _evar_0_1 = fun w -> eqbP h0 h4 y0 w in
    (match _top_assumption_ with
     | Coq_inl x0 -> _evar_0_0 x0
     | Coq_inr x0 -> _evar_0_1 x0)
  in
  (match x with
   | Coq_inl x0 -> _evar_0_ x0 y
   | Coq_inr x0 -> _evar_0_0 x0 y)

(** val sum_setoidDec :
    'a1 setoid -> 'a2 setoid -> 'a1 setoidDec -> 'a2 setoidDec -> ('a1, 'a2)
    sum setoidDec **)

let sum_setoidDec h h0 h3 h4 =
  { eqb_ = (sum_eqb h h0 h3 h4); eqbP_ =
    (sum_setoidDec_obligation_1 h h0 h3 h4) }

(** val sum_leb :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec ->
    'a2 setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1, 'a2) sum -> ('a1,
    'a2) sum -> bool **)

let sum_leb h h0 h1 h2 h3 h4 h5 h6 x y =
  match x with
  | Coq_inl x' ->
    (match y with
     | Coq_inl y' -> leb h h1 h3 h5 x' y'
     | Coq_inr b -> true)
  | Coq_inr x' ->
    (match y with
     | Coq_inl a -> false
     | Coq_inr y' -> leb h0 h2 h4 h6 x' y')

(** val sum_posetDec_obligation_1 :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec ->
    'a2 setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1, 'a2) sum -> ('a1,
    'a2) sum -> reflect **)

let sum_posetDec_obligation_1 h h0 h1 h2 h3 h4 h5 h6 x y =
  let _evar_0_ = fun x0 _top_assumption_ ->
    let _evar_0_ = fun z -> lebP h h1 h3 h5 x0 z in
    let _evar_0_0 = fun w -> ReflectT in
    (match _top_assumption_ with
     | Coq_inl x1 -> _evar_0_ x1
     | Coq_inr x1 -> _evar_0_0 x1)
  in
  let _evar_0_0 = fun y0 _top_assumption_ ->
    let _evar_0_0 = fun z -> ReflectF in
    let _evar_0_1 = fun w -> lebP h0 h2 h4 h6 y0 w in
    (match _top_assumption_ with
     | Coq_inl x0 -> _evar_0_0 x0
     | Coq_inr x0 -> _evar_0_1 x0)
  in
  (match x with
   | Coq_inl x0 -> _evar_0_ x0 y
   | Coq_inr x0 -> _evar_0_0 x0 y)

(** val sum_posetDec :
    'a1 setoid -> 'a2 setoid -> 'a1 poset -> 'a2 poset -> 'a1 setoidDec ->
    'a2 setoidDec -> 'a1 posetDec -> 'a2 posetDec -> ('a1, 'a2) sum posetDec **)

let sum_posetDec h h0 h1 h2 h3 h4 h5 h6 =
  { leb_ = (sum_leb h h0 h1 h2 h3 h4 h5 h6); lebP_ =
    (sum_posetDec_obligation_1 h h0 h1 h2 h3 h4 h5 h6) }

(** val list_setoid : 'a1 setoid -> 'a1 list setoid **)

let list_setoid h =
  Setoid

(** val list_poset : 'a1 setoid -> 'a1 poset -> 'a1 list poset **)

let list_poset h h0 =
  Poset

(** val list_eqb :
    'a1 setoid -> 'a1 setoidDec -> 'a1 list -> 'a1 list -> bool **)

let rec list_eqb h h1 x y =
  match x with
  | [] ->
    (match y with
     | [] -> true
     | a :: l -> false)
  | lelt :: x' ->
    (match y with
     | [] -> false
     | relt :: y' -> (&&) (eqb h h1 lelt relt) (list_eqb h h1 x' y'))

(** val list_setoidDec_obligation_1 :
    'a1 setoid -> 'a1 setoidDec -> 'a1 list -> 'a1 list -> reflect **)

let list_setoidDec_obligation_1 h h1 x y =
  let _evar_0_ = fun _top_assumption_ ->
    let _evar_0_ = ReflectT in
    let _evar_0_0 = fun a l -> ReflectF in
    (match _top_assumption_ with
     | [] -> _evar_0_
     | x0 :: x1 -> _evar_0_0 x0 x1)
  in
  let _evar_0_0 = fun x0 xs iH _top_assumption_ ->
    let _evar_0_0 = ReflectF in
    let _evar_0_1 = fun y0 ys ->
      let _evar_0_1 =
        andP (eqb h h1 x0 y0)
          (let rec list_eqb0 x1 y1 =
             match x1 with
             | [] ->
               (match y1 with
                | [] -> true
                | a :: l -> false)
             | lelt :: x' ->
               (match y1 with
                | [] -> false
                | relt :: y' -> (&&) (eqb h h1 lelt relt) (list_eqb0 x' y'))
           in list_eqb0 xs ys)
      in
      equivP (list_eqb h h1 (x0 :: xs) (y0 :: ys)) _evar_0_1
    in
    (match _top_assumption_ with
     | [] -> _evar_0_0
     | x1 :: x2 -> _evar_0_1 x1 x2)
  in
  let rec f = function
  | [] -> _evar_0_
  | y0 :: l0 -> _evar_0_0 y0 l0 (f l0)
  in f x y

(** val list_setoidDec :
    'a1 setoid -> 'a1 setoidDec -> 'a1 list setoidDec **)

let list_setoidDec h h1 =
  { eqb_ = (list_eqb h h1); eqbP_ = (list_setoidDec_obligation_1 h h1) }

(** val list_leb :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 list ->
    'a1 list -> bool **)

let rec list_leb h h0 h1 h2 x y =
  match x with
  | [] -> true
  | lelt :: x' ->
    (match y with
     | [] -> false
     | relt :: y' ->
       if ltb h h0 h1 h2 lelt relt
       then true
       else if eqb h h1 lelt relt then list_leb h h0 h1 h2 x' y' else false)

(** val list_posetDec_obligation_1 :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 list ->
    'a1 list -> reflect **)

let list_posetDec_obligation_1 h h0 h1 h2 x y =
  let _evar_0_ = fun _top_assumption_ ->
    let _evar_0_ = ReflectT in
    let _evar_0_0 = fun a l -> ReflectT in
    (match _top_assumption_ with
     | [] -> _evar_0_
     | x0 :: x1 -> _evar_0_0 x0 x1)
  in
  let _evar_0_0 = fun x0 xs iH _top_assumption_ ->
    let _evar_0_0 = ReflectF in
    let _evar_0_1 = fun y0 ys ->
      let _evar_0_1 =
        orP (ltb h h0 h1 h2 x0 y0)
          (if eqb h h1 x0 y0
           then let rec list_leb0 x1 y1 =
                  match x1 with
                  | [] -> true
                  | lelt :: x' ->
                    (match y1 with
                     | [] -> false
                     | relt :: y' ->
                       if ltb h h0 h1 h2 lelt relt
                       then true
                       else if eqb h h1 lelt relt
                            then list_leb0 x' y'
                            else false)
                in list_leb0 xs ys
           else false)
      in
      equivP (list_leb h h0 h1 h2 (x0 :: xs) (y0 :: ys)) _evar_0_1
    in
    (match _top_assumption_ with
     | [] -> _evar_0_0
     | x1 :: x2 -> _evar_0_1 x1 x2)
  in
  let rec f = function
  | [] -> _evar_0_
  | y0 :: l0 -> _evar_0_0 y0 l0 (f l0)
  in f x y

(** val list_posetDec :
    'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 list
    posetDec **)

let list_posetDec h h0 h1 h2 =
  { leb_ = (list_leb h h0 h1 h2); lebP_ =
    (list_posetDec_obligation_1 h h0 h1 h2) }

(** val positive_setoid : int setoid **)

let positive_setoid =
  Setoid

(** val positive_poset : int poset **)

let positive_poset =
  Poset

(** val positive_setoidDec_obligation_1 : int -> int -> reflect **)

let positive_setoidDec_obligation_1 x y =
  let _evar_0_ =
    let _evar_0_ = ReflectT in
    let _evar_0_0 = ReflectF in if Pos.eqb x y then _evar_0_ else _evar_0_0
  in
  equivP (Pos.eqb x y) _evar_0_

(** val positive_setoidDec : int setoidDec **)

let positive_setoidDec =
  { eqb_ = Pos.eqb; eqbP_ = positive_setoidDec_obligation_1 }

(** val positive_posetDec_obligation_1 : int -> int -> reflect **)

let positive_posetDec_obligation_1 x y =
  let _evar_0_ =
    let _evar_0_ = ReflectT in
    let _evar_0_0 = ReflectF in if Pos.leb x y then _evar_0_ else _evar_0_0
  in
  equivP (Pos.leb x y) _evar_0_

(** val positive_posetDec : int posetDec **)

let positive_posetDec =
  { leb_ = Pos.leb; lebP_ = positive_posetDec_obligation_1 }

type idT = int

type allocT = idT

type bidT = idT

type fidT = idT

type varT = (idT, idT) sum

(** val varT_setoid : varT setoid **)

let varT_setoid =
  sum_setoid positive_setoid positive_setoid

(** val varT_setoidDec : varT setoidDec **)

let varT_setoidDec =
  sum_setoidDec positive_setoid positive_setoid positive_setoidDec
    positive_setoidDec

(** val varT_poset : varT poset **)

let varT_poset =
  sum_poset positive_setoid positive_setoid positive_poset positive_poset

(** val varT_posetDec : varT posetDec **)

let varT_posetDec =
  sum_posetDec positive_setoid positive_setoid positive_poset positive_poset
    positive_setoidDec positive_setoidDec positive_posetDec positive_posetDec

type op1 =
| Coq_op_not
| Coq_op_bnot

type op2 =
| Coq_op_add
| Coq_op_sub
| Coq_op_mul
| Coq_op_div
| Coq_op_mod
| Coq_op_lt
| Coq_op_le
| Coq_op_gt
| Coq_op_ge
| Coq_op_eq
| Coq_op_neq
| Coq_op_and
| Coq_op_or
| Coq_op_band
| Coq_op_bor
| Coq_op_bxor
| Coq_op_lshift
| Coq_op_rshift

