open BinInt
open Datatypes
open DomType
open DomUtil
open DomZ
open ZArith_dec
open Ssrbool

let __ = let rec f _ = Obj.repr f in Obj.repr f

type itvT' =
| Coq_itv'_top
| Coq_itv'_inf_z of int
| Coq_itv'_z_inf of int
| Coq_itv'_z_z of int * int

(** val itv'_btop : itvT' **)

let itv'_btop =
  Coq_itv'_z_z (0, 1)

(** val itvT'_setoid : itvT' setoid **)

let itvT'_setoid =
  Setoid

(** val itvT'_poset : itvT' poset **)

let itvT'_poset =
  Poset

(** val itvT'_hasTop : itvT' hasTop **)

let itvT'_hasTop =
  Coq_itv'_top

(** val itvT'_hasJoin : itvT' hasJoin **)

let itvT'_hasJoin lhs y =
  match lhs with
  | Coq_itv'_top ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z wildcard' -> Coq_itv'_top
     | _ -> Coq_itv'_top)
  | Coq_itv'_inf_z zlhs_ub ->
    (match y with
     | Coq_itv'_inf_z zy_ub -> Coq_itv'_inf_z (Z.max zlhs_ub zy_ub)
     | Coq_itv'_z_z (wildcard', zy_ub) ->
       Coq_itv'_inf_z (Z.max zlhs_ub zy_ub)
     | _ -> Coq_itv'_top)
  | Coq_itv'_z_inf zlhs_lb ->
    (match y with
     | Coq_itv'_z_inf zy_lb -> Coq_itv'_z_inf (Z.min zlhs_lb zy_lb)
     | Coq_itv'_z_z (zy_lb, wildcard') ->
       Coq_itv'_z_inf (Z.min zlhs_lb zy_lb)
     | _ -> Coq_itv'_top)
  | Coq_itv'_z_z (zlhs_lb, zlhs_ub) ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z zy_ub -> Coq_itv'_inf_z (Z.max zlhs_ub zy_ub)
     | Coq_itv'_z_inf zy_lb -> Coq_itv'_z_inf (Z.min zlhs_lb zy_lb)
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       Coq_itv'_z_z ((Z.min zlhs_lb zy_lb), (Z.max zlhs_ub zy_ub)))

(** val itvT'_setoidDec_obligation_1 : itvT' -> itvT' -> reflect **)

let itvT'_setoidDec_obligation_1 x y =
  let _evar_0_ =
    let _evar_0_ = ReflectT in
    let _evar_0_0 = fun u -> ReflectF in
    let _evar_0_1 = fun l -> ReflectF in
    let _evar_0_2 = fun l u -> ReflectF in
    (match y with
     | Coq_itv'_top -> _evar_0_
     | Coq_itv'_inf_z x0 -> _evar_0_0 x0
     | Coq_itv'_z_inf x0 -> _evar_0_1 x0
     | Coq_itv'_z_z (x0, x1) -> _evar_0_2 x0 x1)
  in
  let _evar_0_0 =
    let _evar_0_0 = fun u -> ReflectF in
    let _evar_0_1 = fun _u_ _u1_ ->
      eqbP coq_Z_setoid coq_Z_setoidDec _u1_ _u_
    in
    let _evar_0_2 = fun l u -> ReflectF in
    let _evar_0_3 = fun l u u0 -> ReflectF in
    (match y with
     | Coq_itv'_top -> _evar_0_0
     | Coq_itv'_inf_z x0 -> _evar_0_1 x0
     | Coq_itv'_z_inf x0 -> _evar_0_2 x0
     | Coq_itv'_z_z (x0, x1) -> (fun u0 -> _evar_0_3 x0 x1 u0))
  in
  let _evar_0_1 =
    let _evar_0_1 = fun l -> ReflectF in
    let _evar_0_2 = fun u l -> ReflectF in
    let _evar_0_3 = fun _l_ _l1_ ->
      eqbP coq_Z_setoid coq_Z_setoidDec _l1_ _l_
    in
    let _evar_0_4 = fun l u l1 -> ReflectF in
    (match y with
     | Coq_itv'_top -> _evar_0_1
     | Coq_itv'_inf_z x0 -> _evar_0_2 x0
     | Coq_itv'_z_inf x0 -> _evar_0_3 x0
     | Coq_itv'_z_z (x0, x1) -> (fun l1 -> _evar_0_4 x0 x1 l1))
  in
  let _evar_0_2 =
    let _evar_0_2 = fun l u -> ReflectF in
    let _evar_0_3 = fun u l u0 -> ReflectF in
    let _evar_0_4 = fun l l0 u -> ReflectF in
    let _evar_0_5 = fun xl xu yl yu ->
      let _evar_0_5 =
        andP (eqb coq_Z_setoid coq_Z_setoidDec yl xl)
          (eqb coq_Z_setoid coq_Z_setoidDec yu xu)
      in
      equivP
        ((&&) (eqb coq_Z_setoid coq_Z_setoidDec yl xl)
          (eqb coq_Z_setoid coq_Z_setoidDec yu xu)) _evar_0_5
    in
    (fun l u _ ->
    match y with
    | Coq_itv'_top -> _evar_0_2 l u
    | Coq_itv'_inf_z x0 -> _evar_0_3 x0 l u
    | Coq_itv'_z_inf x0 -> _evar_0_4 x0 l u
    | Coq_itv'_z_z (x0, x1) -> _evar_0_5 x0 x1 l u)
  in
  (match x with
   | Coq_itv'_top -> _evar_0_
   | Coq_itv'_inf_z x0 -> _evar_0_0 x0
   | Coq_itv'_z_inf x0 -> _evar_0_1 x0
   | Coq_itv'_z_z (x0, x1) -> _evar_0_2 x0 x1 __)

(** val itvT'_setoidDec : itvT' setoidDec **)

let itvT'_setoidDec =
  { eqb_ = (fun x y ->
    match x with
    | Coq_itv'_top ->
      (match y with
       | Coq_itv'_top -> true
       | Coq_itv'_inf_z wildcard' -> false
       | _ -> false)
    | Coq_itv'_inf_z wildcard' ->
      (match y with
       | Coq_itv'_top -> false
       | Coq_itv'_inf_z zy_ub ->
         eqb coq_Z_setoid coq_Z_setoidDec wildcard' zy_ub
       | _ -> false)
    | Coq_itv'_z_inf wildcard' ->
      (match y with
       | Coq_itv'_top -> false
       | Coq_itv'_z_inf zy_lb ->
         eqb coq_Z_setoid coq_Z_setoidDec wildcard' zy_lb
       | _ -> false)
    | Coq_itv'_z_z (zx_lb, zx_ub) ->
      (match y with
       | Coq_itv'_top -> false
       | Coq_itv'_z_z (zy_lb, zy_ub) ->
         (&&) (eqb coq_Z_setoid coq_Z_setoidDec zx_lb zy_lb)
           (eqb coq_Z_setoid coq_Z_setoidDec zx_ub zy_ub)
       | _ -> false)); eqbP_ = itvT'_setoidDec_obligation_1 }

(** val itvT'_posetDec_obligation_1 : itvT' -> itvT' -> reflect **)

let itvT'_posetDec_obligation_1 x y =
  let _evar_0_ =
    let _evar_0_ = ReflectT in
    let _evar_0_0 = fun u -> ReflectF in
    let _evar_0_1 = fun l -> ReflectF in
    let _evar_0_2 = fun l u -> ReflectF in
    (match y with
     | Coq_itv'_top -> _evar_0_
     | Coq_itv'_inf_z x0 -> _evar_0_0 x0
     | Coq_itv'_z_inf x0 -> _evar_0_1 x0
     | Coq_itv'_z_z (x0, x1) -> _evar_0_2 x0 x1)
  in
  let _evar_0_0 =
    let _evar_0_0 = fun u -> ReflectT in
    let _evar_0_1 = fun _u_ _u1_ ->
      lebP coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec _u1_ _u_
    in
    let _evar_0_2 = fun l u -> ReflectF in
    let _evar_0_3 = fun l u u0 -> ReflectF in
    (match y with
     | Coq_itv'_top -> _evar_0_0
     | Coq_itv'_inf_z x0 -> _evar_0_1 x0
     | Coq_itv'_z_inf x0 -> _evar_0_2 x0
     | Coq_itv'_z_z (x0, x1) -> (fun u0 -> _evar_0_3 x0 x1 u0))
  in
  let _evar_0_1 =
    let _evar_0_1 = fun l -> ReflectT in
    let _evar_0_2 = fun u l -> ReflectF in
    let _evar_0_3 = fun _l_ _l1_ ->
      lebP coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec _l_ _l1_
    in
    let _evar_0_4 = fun l u l1 -> ReflectF in
    (match y with
     | Coq_itv'_top -> _evar_0_1
     | Coq_itv'_inf_z x0 -> _evar_0_2 x0
     | Coq_itv'_z_inf x0 -> _evar_0_3 x0
     | Coq_itv'_z_z (x0, x1) -> (fun l1 -> _evar_0_4 x0 x1 l1))
  in
  let _evar_0_2 =
    let _evar_0_2 = fun l u -> ReflectT in
    let _evar_0_3 = fun _u_ _l_ _u1_ ->
      lebP coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec _u1_ _u_
    in
    let _evar_0_4 = fun _l_ _l1_ _u_ ->
      lebP coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec _l_ _l1_
    in
    let _evar_0_5 = fun xl xu yl yu ->
      let _evar_0_5 =
        andP
          (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec xl yl)
          (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec yu xu)
      in
      equivP
        ((&&)
          (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec xl yl)
          (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec yu xu))
        _evar_0_5
    in
    (fun l u _ ->
    match y with
    | Coq_itv'_top -> _evar_0_2 l u
    | Coq_itv'_inf_z x0 -> _evar_0_3 x0 l u
    | Coq_itv'_z_inf x0 -> _evar_0_4 x0 l u
    | Coq_itv'_z_z (x0, x1) -> _evar_0_5 x0 x1 l u)
  in
  (match x with
   | Coq_itv'_top -> _evar_0_
   | Coq_itv'_inf_z x0 -> _evar_0_0 x0
   | Coq_itv'_z_inf x0 -> _evar_0_1 x0
   | Coq_itv'_z_z (x0, x1) -> _evar_0_2 x0 x1 __)

(** val itvT'_posetDec : itvT' posetDec **)

let itvT'_posetDec =
  { leb_ = (fun x y ->
    match x with
    | Coq_itv'_top ->
      (match y with
       | Coq_itv'_top -> true
       | Coq_itv'_inf_z wildcard' -> false
       | _ -> false)
    | Coq_itv'_inf_z wildcard' ->
      (match y with
       | Coq_itv'_top -> true
       | Coq_itv'_inf_z zy_ub ->
         leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
           wildcard' zy_ub
       | _ -> false)
    | Coq_itv'_z_inf wildcard' ->
      (match y with
       | Coq_itv'_top -> true
       | Coq_itv'_z_inf zy_lb ->
         leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_lb
           wildcard'
       | _ -> false)
    | Coq_itv'_z_z (zx_lb, zx_ub) ->
      (match y with
       | Coq_itv'_top -> true
       | Coq_itv'_inf_z zy_ub ->
         leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
           zy_ub
       | Coq_itv'_z_inf zy_lb ->
         leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_lb
           zx_lb
       | Coq_itv'_z_z (zy_lb, zy_ub) ->
         (&&)
           (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_lb
             zx_lb)
           (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
             zy_ub))); lebP_ = itvT'_posetDec_obligation_1 }

(** val op_add' : itvT' -> itvT' -> itvT' **)

let op_add' x y =
  match x with
  | Coq_itv'_top ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z wildcard' -> Coq_itv'_top
     | _ -> Coq_itv'_top)
  | Coq_itv'_inf_z zx_ub ->
    (match y with
     | Coq_itv'_inf_z zy_ub -> Coq_itv'_inf_z (Z.add zx_ub zy_ub)
     | Coq_itv'_z_z (wildcard', zy_ub) -> Coq_itv'_inf_z (Z.add zx_ub zy_ub)
     | _ -> Coq_itv'_top)
  | Coq_itv'_z_inf zx_lb ->
    (match y with
     | Coq_itv'_z_inf zy_lb -> Coq_itv'_z_inf (Z.add zx_lb zy_lb)
     | Coq_itv'_z_z (zy_lb, wildcard') -> Coq_itv'_z_inf (Z.add zx_lb zy_lb)
     | _ -> Coq_itv'_top)
  | Coq_itv'_z_z (zx_lb, zx_ub) ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z zy_ub -> Coq_itv'_inf_z (Z.add zx_ub zy_ub)
     | Coq_itv'_z_inf zy_lb -> Coq_itv'_z_inf (Z.add zx_lb zy_lb)
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       Coq_itv'_z_z ((Z.add zx_lb zy_lb), (Z.add zx_ub zy_ub)))

(** val op_sub' : itvT' -> itvT' -> itvT' **)

let op_sub' x y =
  match x with
  | Coq_itv'_top ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z wildcard' -> Coq_itv'_top
     | _ -> Coq_itv'_top)
  | Coq_itv'_inf_z zx_ub ->
    (match y with
     | Coq_itv'_z_inf zy_lb -> Coq_itv'_inf_z (Z.sub zx_ub zy_lb)
     | Coq_itv'_z_z (zy_lb, wildcard') -> Coq_itv'_inf_z (Z.sub zx_ub zy_lb)
     | _ -> Coq_itv'_top)
  | Coq_itv'_z_inf zx_lb ->
    (match y with
     | Coq_itv'_inf_z zy_ub -> Coq_itv'_z_inf (Z.sub zx_lb zy_ub)
     | Coq_itv'_z_z (wildcard', zy_ub) -> Coq_itv'_z_inf (Z.sub zx_lb zy_ub)
     | _ -> Coq_itv'_top)
  | Coq_itv'_z_z (zx_lb, zx_ub) ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z zy_ub -> Coq_itv'_z_inf (Z.sub zx_lb zy_ub)
     | Coq_itv'_z_inf zy_lb -> Coq_itv'_inf_z (Z.sub zx_ub zy_lb)
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       Coq_itv'_z_z ((Z.sub zx_lb zy_ub), (Z.sub zx_ub zy_lb)))

(** val op_mul' : itvT' -> itvT' -> itvT' **)

let op_mul' x y =
  match x with
  | Coq_itv'_top ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if (&&) (eqb coq_Z_setoid coq_Z_setoidDec zy_lb 0)
            (eqb coq_Z_setoid coq_Z_setoidDec zy_ub 0)
       then Coq_itv'_z_z (0, 0)
       else Coq_itv'_top
     | _ -> Coq_itv'_top)
  | Coq_itv'_inf_z zx_ub ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z zy_ub ->
       if (&&)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
              zx_ub 0)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
              zy_ub 0)
       then Coq_itv'_z_inf (Z.mul zx_ub zy_ub)
       else Coq_itv'_top
     | Coq_itv'_z_inf zy_lb ->
       if (&&)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
              zx_ub 0)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
              zy_lb)
       then Coq_itv'_inf_z (Z.mul zx_ub zy_lb)
       else Coq_itv'_top
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if (&&) (eqb coq_Z_setoid coq_Z_setoidDec zy_lb 0)
            (eqb coq_Z_setoid coq_Z_setoidDec zy_ub 0)
       then Coq_itv'_z_z (0, 0)
       else if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
                 zy_lb
            then Coq_itv'_inf_z
                   (Z.max (Z.mul zx_ub zy_lb) (Z.mul zx_ub zy_ub))
            else if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec
                      coq_Z_posetDec zy_ub 0
                 then Coq_itv'_z_inf
                        (Z.min (Z.mul zx_ub zy_lb) (Z.mul zx_ub zy_ub))
                 else Coq_itv'_top)
  | Coq_itv'_z_inf zx_lb ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z zy_ub ->
       if (&&)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
              zx_lb)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
              zy_ub 0)
       then Coq_itv'_inf_z (Z.mul zx_lb zy_ub)
       else Coq_itv'_top
     | Coq_itv'_z_inf zy_lb ->
       if (&&)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
              zx_lb)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
              zy_lb)
       then Coq_itv'_z_inf (Z.mul zx_lb zy_lb)
       else Coq_itv'_top
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if (&&) (eqb coq_Z_setoid coq_Z_setoidDec zy_lb 0)
            (eqb coq_Z_setoid coq_Z_setoidDec zy_ub 0)
       then Coq_itv'_z_z (0, 0)
       else if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
                 zy_lb
            then Coq_itv'_z_inf
                   (Z.min (Z.mul zx_lb zy_lb) (Z.mul zx_lb zy_ub))
            else if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec
                      coq_Z_posetDec zy_ub 0
                 then Coq_itv'_inf_z
                        (Z.max (Z.mul zx_lb zy_lb) (Z.mul zx_lb zy_ub))
                 else Coq_itv'_top)
  | Coq_itv'_z_z (zx_lb, zx_ub) ->
    (match y with
     | Coq_itv'_top ->
       if (&&) (eqb coq_Z_setoid coq_Z_setoidDec zx_lb 0)
            (eqb coq_Z_setoid coq_Z_setoidDec zx_ub 0)
       then Coq_itv'_z_z (0, 0)
       else Coq_itv'_top
     | Coq_itv'_inf_z zy_ub ->
       if (&&) (eqb coq_Z_setoid coq_Z_setoidDec zx_lb 0)
            (eqb coq_Z_setoid coq_Z_setoidDec zx_ub 0)
       then Coq_itv'_z_z (0, 0)
       else if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
                 zx_lb
            then Coq_itv'_inf_z
                   (Z.max (Z.mul zx_lb zy_ub) (Z.mul zx_ub zy_ub))
            else if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec
                      coq_Z_posetDec zx_ub 0
                 then Coq_itv'_z_inf
                        (Z.min (Z.mul zx_lb zy_ub) (Z.mul zx_ub zy_ub))
                 else Coq_itv'_top
     | Coq_itv'_z_inf zy_lb ->
       if (&&) (eqb coq_Z_setoid coq_Z_setoidDec zx_lb 0)
            (eqb coq_Z_setoid coq_Z_setoidDec zx_ub 0)
       then Coq_itv'_z_z (0, 0)
       else if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
                 zx_lb
            then Coq_itv'_z_inf
                   (Z.min (Z.mul zx_lb zy_lb) (Z.mul zx_ub zy_lb))
            else if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec
                      coq_Z_posetDec zx_ub 0
                 then Coq_itv'_inf_z
                        (Z.max (Z.mul zx_lb zy_lb) (Z.mul zx_ub zy_lb))
                 else Coq_itv'_top
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       Coq_itv'_z_z
         ((Z.min (Z.min (Z.mul zx_lb zy_lb) (Z.mul zx_lb zy_ub))
            (Z.min (Z.mul zx_ub zy_lb) (Z.mul zx_ub zy_ub))),
         (Z.max (Z.max (Z.mul zx_lb zy_lb) (Z.mul zx_lb zy_ub))
           (Z.max (Z.mul zx_ub zy_lb) (Z.mul zx_ub zy_ub)))))

(** val op_div' : itvT' -> itvT' -> itvT' **)

let op_div' x y =
  match x with
  | Coq_itv'_top ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z wildcard' -> Coq_itv'_top
     | _ -> Coq_itv'_top)
  | Coq_itv'_inf_z zx_ub ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z zy_ub ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0 zy_ub
       then Coq_itv'_top
       else Coq_itv'_z_inf (Z.min (coq_Cdiv zx_ub zy_ub) 0)
     | Coq_itv'_z_inf zy_lb ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_lb 0
       then Coq_itv'_top
       else Coq_itv'_inf_z (Z.max (coq_Cdiv zx_ub zy_lb) 0)
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if (&&)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
              zy_lb 0)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
              zy_ub)
       then Coq_itv'_top
       else if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
                 zy_lb
            then Coq_itv'_inf_z
                   (Z.max (coq_Cdiv zx_ub zy_lb) (coq_Cdiv zx_ub zy_ub))
            else Coq_itv'_z_inf
                   (Z.min (coq_Cdiv zx_ub zy_lb) (coq_Cdiv zx_ub zy_ub)))
  | Coq_itv'_z_inf zx_lb ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z zy_ub ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0 zy_ub
       then Coq_itv'_top
       else Coq_itv'_inf_z (Z.max (coq_Cdiv zx_lb zy_ub) 0)
     | Coq_itv'_z_inf zy_lb ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_lb 0
       then Coq_itv'_top
       else Coq_itv'_z_inf (Z.min (coq_Cdiv zx_lb zy_lb) 0)
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if (&&)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
              zy_lb 0)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
              zy_ub)
       then Coq_itv'_top
       else if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
                 zy_lb
            then Coq_itv'_z_inf
                   (Z.min (coq_Cdiv zx_lb zy_lb) (coq_Cdiv zx_lb zy_ub))
            else Coq_itv'_inf_z
                   (Z.max (coq_Cdiv zx_lb zy_lb) (coq_Cdiv zx_lb zy_ub)))
  | Coq_itv'_z_z (zx_lb, zx_ub) ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z zy_ub ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0 zy_ub
       then Coq_itv'_top
       else Coq_itv'_z_z ((Z.min (coq_Cdiv zx_ub zy_ub) 0),
              (Z.max (coq_Cdiv zx_lb zy_ub) 0))
     | Coq_itv'_z_inf zy_lb ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_lb 0
       then Coq_itv'_top
       else Coq_itv'_z_z ((Z.min (coq_Cdiv zx_lb zy_lb) 0),
              (Z.max (coq_Cdiv zx_ub zy_lb) 0))
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if (&&)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
              zy_lb 0)
            (leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec 0
              zy_ub)
       then Coq_itv'_top
       else Coq_itv'_z_z
              ((Z.min (Z.min (coq_Cdiv zx_lb zy_lb) (coq_Cdiv zx_lb zy_ub))
                 (Z.min (coq_Cdiv zx_ub zy_lb) (coq_Cdiv zx_ub zy_ub))),
              (Z.max (Z.max (coq_Cdiv zx_lb zy_lb) (coq_Cdiv zx_lb zy_ub))
                (Z.max (coq_Cdiv zx_ub zy_lb) (coq_Cdiv zx_ub zy_ub)))))

(** val op_mod' : itvT' -> itvT' -> itvT' **)

let op_mod' x y =
  match x with
  | Coq_itv'_top ->
    (match y with
     | Coq_itv'_z_z (dl, du) ->
       let s = l_z_u_dec dl du in
       if s
       then Coq_itv'_top
       else Coq_itv'_z_z ((Z.opp (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1)),
              (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1))
     | _ -> Coq_itv'_top)
  | Coq_itv'_inf_z u ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z du ->
       let s = coq_Z_le_dec 0 du in
       if s
       then Coq_itv'_top
       else let s0 = coq_Z_le_dec u 0 in
            if s0 then Coq_itv'_inf_z 0 else Coq_itv'_inf_z u
     | Coq_itv'_z_inf dl ->
       let s = coq_Z_le_dec dl 0 in
       if s
       then Coq_itv'_top
       else let s0 = coq_Z_le_dec u 0 in
            if s0 then Coq_itv'_inf_z 0 else Coq_itv'_inf_z u
     | Coq_itv'_z_z (dl, du) ->
       let s = l_z_u_dec dl du in
       if s
       then Coq_itv'_top
       else let s0 = coq_Z_le_dec u 0 in
            if s0
            then Coq_itv'_z_z
                   ((Z.opp (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1)), 0)
            else Coq_itv'_z_z
                   ((Z.opp (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1)),
                   (Z.min u (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1))))
  | Coq_itv'_z_inf l ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z du ->
       let s = coq_Z_le_dec 0 du in
       if s
       then Coq_itv'_top
       else let s0 = coq_Z_le_dec 0 l in
            if s0 then Coq_itv'_z_inf 0 else Coq_itv'_z_inf l
     | Coq_itv'_z_inf dl ->
       let s = coq_Z_le_dec dl 0 in
       if s
       then Coq_itv'_top
       else let s0 = coq_Z_le_dec 0 l in
            if s0 then Coq_itv'_z_inf 0 else Coq_itv'_z_inf l
     | Coq_itv'_z_z (dl, du) ->
       let s = l_z_u_dec dl du in
       if s
       then Coq_itv'_top
       else let s0 = coq_Z_le_dec 0 l in
            if s0
            then Coq_itv'_z_z (0, (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1))
            else Coq_itv'_z_z
                   ((Z.opp
                      (Z.min (Z.opp l)
                        (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1))),
                   (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1)))
  | Coq_itv'_z_z (l, u) ->
    (match y with
     | Coq_itv'_top -> Coq_itv'_top
     | Coq_itv'_inf_z du ->
       let s = coq_Z_le_dec 0 du in
       if s
       then Coq_itv'_top
       else let s0 = coq_Z_le_dec 0 l in
            if s0
            then Coq_itv'_z_z (0, u)
            else let s1 = coq_Z_le_dec u 0 in
                 if s1 then Coq_itv'_z_z (l, 0) else Coq_itv'_z_z (l, u)
     | Coq_itv'_z_inf dl ->
       let s = coq_Z_le_dec dl 0 in
       if s
       then Coq_itv'_top
       else let s0 = coq_Z_le_dec 0 l in
            if s0
            then Coq_itv'_z_z (0, u)
            else let s1 = coq_Z_le_dec u 0 in
                 if s1 then Coq_itv'_z_z (l, 0) else Coq_itv'_z_z (l, u)
     | Coq_itv'_z_z (dl, du) ->
       let s = l_z_u_dec dl du in
       if s
       then Coq_itv'_top
       else let s0 = coq_Z_le_dec 0 l in
            if s0
            then Coq_itv'_z_z (0,
                   (Z.min u (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1)))
            else let s1 = coq_Z_le_dec u 0 in
                 if s1
                 then Coq_itv'_z_z
                        ((Z.opp
                           (Z.min (Z.opp l)
                             (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1))), 0)
                 else Coq_itv'_z_z
                        ((Z.opp
                           (Z.min (Z.opp l)
                             (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1))),
                        (Z.min u (Z.sub (Z.max (Z.abs dl) (Z.abs du)) 1))))

(** val op_lt' : itvT' -> itvT' -> itvT' **)

let op_lt' x y =
  match x with
  | Coq_itv'_top ->
    (match y with
     | Coq_itv'_top -> itv'_btop
     | Coq_itv'_inf_z wildcard' -> itv'_btop
     | _ -> itv'_btop)
  | Coq_itv'_inf_z zx_ub ->
    (match y with
     | Coq_itv'_z_inf zy_lb ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (1, 1)
       else itv'_btop
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (1, 1)
       else itv'_btop
     | _ -> itv'_btop)
  | Coq_itv'_z_inf zx_lb ->
    (match y with
     | Coq_itv'_inf_z zy_ub ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_ub
            zx_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_ub
            zx_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | _ -> itv'_btop)
  | Coq_itv'_z_z (zx_lb, zx_ub) ->
    (match y with
     | Coq_itv'_top -> itv'_btop
     | Coq_itv'_inf_z zy_ub ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_ub
            zx_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | Coq_itv'_z_inf zy_lb ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (1, 1)
       else itv'_btop
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (1, 1)
       else if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
                 zy_ub zx_lb
            then Coq_itv'_z_z (0, 0)
            else itv'_btop)

(** val op_le' : itvT' -> itvT' -> itvT' **)

let op_le' x y =
  match x with
  | Coq_itv'_top ->
    (match y with
     | Coq_itv'_top -> itv'_btop
     | Coq_itv'_inf_z wildcard' -> itv'_btop
     | _ -> itv'_btop)
  | Coq_itv'_inf_z zx_ub ->
    (match y with
     | Coq_itv'_z_inf zy_lb ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (1, 1)
       else itv'_btop
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (1, 1)
       else itv'_btop
     | _ -> itv'_btop)
  | Coq_itv'_z_inf zx_lb ->
    (match y with
     | Coq_itv'_inf_z zy_ub ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_ub
            zx_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_ub
            zx_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | _ -> itv'_btop)
  | Coq_itv'_z_z (zx_lb, zx_ub) ->
    (match y with
     | Coq_itv'_top -> itv'_btop
     | Coq_itv'_inf_z zy_ub ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_ub
            zx_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | Coq_itv'_z_inf zy_lb ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (1, 1)
       else itv'_btop
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if leb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (1, 1)
       else if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
                 zy_ub zx_lb
            then Coq_itv'_z_z (0, 0)
            else itv'_btop)

(** val op_gt' : itvT' -> itvT' -> itvT' **)

let op_gt' x y =
  op_lt' y x

(** val op_ge' : itvT' -> itvT' -> itvT' **)

let op_ge' x y =
  op_le' y x

(** val op_eq' : itvT' -> itvT' -> itvT' **)

let op_eq' x y =
  match x with
  | Coq_itv'_top ->
    (match y with
     | Coq_itv'_top -> itv'_btop
     | Coq_itv'_inf_z wildcard' -> itv'_btop
     | _ -> itv'_btop)
  | Coq_itv'_inf_z zx_ub ->
    (match y with
     | Coq_itv'_z_inf zy_lb ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | _ -> itv'_btop)
  | Coq_itv'_z_inf zx_lb ->
    (match y with
     | Coq_itv'_inf_z zy_ub ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_ub
            zx_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_ub
            zx_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | _ -> itv'_btop)
  | Coq_itv'_z_z (zx_lb, zx_ub) ->
    (match y with
     | Coq_itv'_top -> itv'_btop
     | Coq_itv'_inf_z zy_ub ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zy_ub
            zx_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | Coq_itv'_z_inf zy_lb ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (0, 0)
       else itv'_btop
     | Coq_itv'_z_z (zy_lb, zy_ub) ->
       if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec zx_ub
            zy_lb
       then Coq_itv'_z_z (0, 0)
       else if ltb coq_Z_setoid coq_Z_poset coq_Z_setoidDec coq_Z_posetDec
                 zy_ub zx_lb
            then Coq_itv'_z_z (0, 0)
            else if (&&)
                      ((&&) (eqb coq_Z_setoid coq_Z_setoidDec zx_lb zx_ub)
                        (eqb coq_Z_setoid coq_Z_setoidDec zx_ub zy_lb))
                      (eqb coq_Z_setoid coq_Z_setoidDec zy_lb zy_ub)
                 then Coq_itv'_z_z (1, 1)
                 else itv'_btop)

(** val op_not' : itvT' -> itvT' **)

let op_not' x =
  if eqb itvT'_setoid itvT'_setoidDec (Coq_itv'_z_z (0, 0)) x
  then Coq_itv'_z_z (1, 1)
  else if leb itvT'_setoid itvT'_poset itvT'_setoidDec itvT'_posetDec
            (Coq_itv'_z_z (0, 0)) x
       then itv'_btop
       else Coq_itv'_z_z (0, 0)

(** val op_neq' : itvT' -> itvT' -> itvT' **)

let op_neq' x y =
  op_not' (op_eq' x y)

(** val op_and' : itvT' -> itvT' -> itvT' **)

let op_and' x y =
  if eqb itvT'_setoid itvT'_setoidDec (Coq_itv'_z_z (0, 0)) x
  then Coq_itv'_z_z (0, 0)
  else if eqb itvT'_setoid itvT'_setoidDec (Coq_itv'_z_z (0, 0)) y
       then Coq_itv'_z_z (0, 0)
       else if (&&)
                 (negb
                   (leb itvT'_setoid itvT'_poset itvT'_setoidDec
                     itvT'_posetDec (Coq_itv'_z_z (0, 0)) x))
                 (negb
                   (leb itvT'_setoid itvT'_poset itvT'_setoidDec
                     itvT'_posetDec (Coq_itv'_z_z (0, 0)) y))
            then Coq_itv'_z_z (1, 1)
            else itv'_btop

(** val op_or' : itvT' -> itvT' -> itvT' **)

let op_or' x y =
  if (&&) (eqb itvT'_setoid itvT'_setoidDec (Coq_itv'_z_z (0, 0)) x)
       (eqb itvT'_setoid itvT'_setoidDec (Coq_itv'_z_z (0, 0)) y)
  then Coq_itv'_z_z (0, 0)
  else if (||)
            (negb
              (leb itvT'_setoid itvT'_poset itvT'_setoidDec itvT'_posetDec
                (Coq_itv'_z_z (0, 0)) x))
            (negb
              (leb itvT'_setoid itvT'_poset itvT'_setoidDec itvT'_posetDec
                (Coq_itv'_z_z (0, 0)) y))
       then Coq_itv'_z_z (1, 1)
       else itv'_btop

(** val op_band' : itvT' -> itvT' -> itvT' **)

let op_band' x y =
  Coq_itv'_top

(** val op_bor' : itvT' -> itvT' -> itvT' **)

let op_bor' x y =
  Coq_itv'_top

(** val op_bxor' : itvT' -> itvT' -> itvT' **)

let op_bxor' x y =
  Coq_itv'_top

(** val op_lshift' : itvT' -> itvT' -> itvT' **)

let op_lshift' x y =
  Coq_itv'_top

(** val op_rshift' : itvT' -> itvT' -> itvT' **)

let op_rshift' x y =
  Coq_itv'_top

(** val op_bnot' : itvT' -> itvT' **)

let op_bnot' x =
  Coq_itv'_top

type itvT = itvT' option

(** val op_add : itvT -> itvT -> itvT **)

let op_add =
  lift2 op_add'

(** val op_sub : itvT -> itvT -> itvT **)

let op_sub =
  lift2 op_sub'

(** val op_mul : itvT -> itvT -> itvT **)

let op_mul =
  lift2 op_mul'

(** val op_div : itvT -> itvT -> itvT **)

let op_div =
  lift2 op_div'

(** val op_mod : itvT -> itvT -> itvT **)

let op_mod =
  lift2 op_mod'

(** val op_lt : itvT -> itvT -> itvT **)

let op_lt =
  lift2 op_lt'

(** val op_le : itvT -> itvT -> itvT **)

let op_le =
  lift2 op_le'

(** val op_gt : itvT -> itvT -> itvT **)

let op_gt =
  lift2 op_gt'

(** val op_ge : itvT -> itvT -> itvT **)

let op_ge =
  lift2 op_ge'

(** val op_eq : itvT -> itvT -> itvT **)

let op_eq =
  lift2 op_eq'

(** val op_neq : itvT -> itvT -> itvT **)

let op_neq =
  lift2 op_neq'

(** val op_and : itvT -> itvT -> itvT **)

let op_and =
  lift2 op_and'

(** val op_or : itvT -> itvT -> itvT **)

let op_or =
  lift2 op_or'

(** val op_band : itvT -> itvT -> itvT **)

let op_band =
  lift2 op_band'

(** val op_bor : itvT -> itvT -> itvT **)

let op_bor =
  lift2 op_bor'

(** val op_bxor : itvT -> itvT -> itvT **)

let op_bxor =
  lift2 op_bxor'

(** val op_lshift : itvT -> itvT -> itvT **)

let op_lshift =
  lift2 op_lshift'

(** val op_rshift : itvT -> itvT -> itvT **)

let op_rshift =
  lift2 op_rshift'

(** val op_not : itvT -> itvT **)

let op_not =
  lift1 op_not'

(** val op_bnot : itvT -> itvT **)

let op_bnot =
  lift1 op_bnot'

