open Datatypes
open DomAbsMem
open DomAbsState
open DomAbsValue
open DomAcc
open DomBasic
open DomBridge
open DomItv
open DomMap
open DomSet
open DomType
open LibTactics
open List0
open MapAVLInstance
open MapInterface
open SemAbsBlock
open SemAccInsen
open SetAVLInstance
open SetInterface
open Syntax
open Ssrbool

val acc_correct_acclocs_blk : (int, string) PMap.t ->
  accT -> fidT -> bidT -> cmdT -> func_stateT -> bool

val acc_correct_acclocs_func : (int, string) PMap.t -> accT -> fidT -> funcT -> func_stateT -> bool

val acc_correct_acclocs_star_func : accT -> fidT -> bool

val acc_correct_acclocs_callfroms_func : accT -> fidT -> bool

val use_le_var : fidT -> varT -> memT -> memT -> bool

val use_le_expr : fidT -> exprT -> memT -> memT -> bool

val use_le_lv : fidT -> lv -> memT -> memT -> bool

val use_le_exprs : fidT -> exprT list -> memT -> memT -> bool

val use_le_locs : fidT -> exprT -> memT -> memT -> bool

val use_le_locss : fidT -> exprT list -> memT -> memT -> bool

val use_le_tmn : fidT -> tmnT -> memT -> memT -> bool

val use_le_instr : accT -> fidT -> instrT -> memT -> memT -> bool

val use_le_instrs : accT -> fidT -> instrT list -> memT -> memT -> bool

val use_le_blk : accT -> fidT -> bidT -> cmdT -> memT -> memT -> bool

val use_le_func : accT -> fidT -> funcT -> func_stateT -> func_stateT -> bool

val eqb_inter_blk :
  fidT -> bidT -> cmdT -> func_stateT -> func_stateT -> bool

val eqb_inter_func : fidT -> funcT -> func_stateT -> func_stateT -> bool

val postfix_jump : func_stateT -> fidT -> funcT -> bidT -> bidT set -> bool

val postfix_call :
  progT -> accT -> func_stateT -> fidT -> funcT -> bidT -> bidT -> fidT ->
  exprT list -> bool

val postfix_block :
  (int, string) PMap.t -> progT -> accT -> func_stateT -> fidT -> funcT -> bidT -> cmdT -> bool

val postfix_func : (int, string) PMap.t -> progT -> accT -> func_stateT -> fidT -> funcT -> bool

val postfix_inter_call :
  (int, string) PMap.t -> progT -> accT -> func_stateT -> stateT' -> fidT -> funcT -> bidT -> bidT ->
  fidT -> exprT list -> bool

val postfix_inter_exit :
  (int, string) PMap.t -> progT -> accT -> func_stateT -> stateT' -> fidT -> funcT -> bidT -> exprT
  -> bool

val postfix_inter_block :
  (int, string) PMap.t -> progT -> accT -> func_stateT -> stateT' -> fidT -> funcT -> bidT -> cmdT ->
  bool

val postfix_inter_func :
  (int, string) PMap.t -> progT -> accT -> stateT' -> fidT -> funcT -> bool

val notop : func_stateT -> bool

val validate_func :
  (int, string) PMap.t -> progT -> accT -> fidT -> funcT -> func_stateT -> func_stateT -> stateT' ->
  bool

val validate : (int, string) PMap.t -> progT -> accT -> stateT' -> stateT' -> stateT' -> bool
