open Datatypes
open List0
open MapInterface
open OrderedType

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

module K = KeyOrderedType

(** val eqb : 'a1 coq_OrderedType -> 'a1 -> 'a1 -> bool **)

let eqb hkey x y =
  is_compare hkey x y Eq

(** val coq_In_dec :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> 'a1 -> bool **)

let coq_In_dec hkey f m x =
  let b = mem hkey f x m in if b then true else false

(** val option_map : ('a1 -> 'a2) -> 'a1 option -> 'a2 option **)

let option_map f = function
| Some a -> Some (f a)
| None -> None

(** val eqb_dec : 'a1 coq_OrderedType -> 'a1 -> 'a1 -> bool **)

let eqb_dec hkey x y =
  match compare hkey x y with
  | Eq -> true
  | _ -> false

(** val of_list :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 * 'a2) list -> ('a1, 'a2)
    dict **)

let of_list hkey f l =
  fold_right (fun p -> add hkey f (fst p) (snd p)) (empty hkey f) l

(** val to_list :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2)
    list **)

let to_list hkey f =
  elements hkey f

(** val fold_rec :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> 'a3
    -> ('a1, 'a2) dict -> (('a1, 'a2) dict -> __ -> 'a4) -> ('a1 -> 'a2 ->
    'a3 -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> __ -> __ -> 'a4 ->
    'a4) -> 'a4 **)

let fold_rec hkey f f0 i m x x0 =
  let ff = fun y x1 -> f0 (fst y) (snd y) x1 in
  let l = rev (elements hkey f m) in
  let hstep' = fun k e a m' m'' x1 ->
    x0 (fst (k, e)) (snd (k, e)) a m' m'' __ __ __ x1
  in
  let rec f1 l0 hstep'0 m0 =
    match l0 with
    | [] -> x m0 __
    | y :: l1 ->
      let (k, e) = y in
      hstep'0 k e (fold_right ff i l1) (of_list hkey f l1) m0 __ __ __
        (f1 l1 (fun k0 e0 a m' m'' _ _ _ x1 ->
          hstep'0 k0 e0 a m' m'' __ __ __ x1) (of_list hkey f l1))
  in f1 l (fun k e a m' m'' _ _ _ x1 -> hstep' k e a m' m'' x1) m

(** val fold_rec_bis :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> 'a3
    -> ('a1, 'a2) dict -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> __ ->
    'a4 -> 'a4) -> 'a4 -> ('a1 -> 'a2 -> 'a3 -> ('a1, 'a2) dict -> __ -> __
    -> 'a4 -> 'a4) -> 'a4 **)

let fold_rec_bis hkey f f0 i m x x0 x1 =
  fold_rec hkey f f0 i m (fun m0 _ -> x (empty hkey f) m0 i __ x0)
    (fun k e a m' m'' _ _ _ x2 ->
    x (add hkey f k e m') m'' (f0 k e a) __ (x1 k e a m' __ __ x2))

(** val fold_rec_nodep :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> 'a3
    -> ('a1, 'a2) dict -> 'a4 -> ('a1 -> 'a2 -> 'a3 -> __ -> 'a4 -> 'a4) ->
    'a4 **)

let fold_rec_nodep hkey f f0 i m x x0 =
  fold_rec_bis hkey f f0 i m (fun m0 m' a _ x1 -> x1) x
    (fun k e a m' _ _ x1 -> x0 k e a __ x1)

(** val fold_rec_weak :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> 'a3
    -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> __ -> 'a4 -> 'a4) -> 'a4
    -> ('a1 -> 'a2 -> 'a3 -> ('a1, 'a2) dict -> __ -> 'a4 -> 'a4) -> ('a1,
    'a2) dict -> 'a4 **)

let fold_rec_weak hkey f f0 i x x0 x1 m =
  fold_rec_bis hkey f f0 i m x x0 (fun k e a m' _ _ x2 -> x1 k e a m' __ x2)

(** val fold_rel :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1
    -> 'a2 -> 'a4 -> 'a4) -> 'a3 -> 'a4 -> ('a1, 'a2) dict -> 'a5 -> ('a1 ->
    'a2 -> 'a3 -> 'a4 -> __ -> 'a5 -> 'a5) -> 'a5 **)

let fold_rel hkey f f0 g i j m x x0 =
  let l = rev (elements hkey f m) in
  let rstep' = fun k e a b x1 -> x0 k e a b __ x1 in
  let rec f1 l0 rstep'0 =
    match l0 with
    | [] -> x
    | y :: l1 ->
      rstep'0 (fst y) (snd y)
        (fold_right (fun y0 x1 -> f0 (fst y0) (snd y0) x1) i l1)
        (fold_right (fun y0 x1 -> g (fst y0) (snd y0) x1) j l1) __
        (f1 l1 (fun k e a0 b _ x1 -> rstep'0 k e a0 b __ x1))
  in f1 l (fun k e a b _ x1 -> rstep' k e a b x1)

(** val map_induction :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> __ -> __ ->
    'a3) -> ('a1, 'a2) dict -> 'a3 **)

let map_induction hkey f x x0 m =
  fold_rec hkey f (fun x1 x2 x3 -> ()) () m x (fun k e a m' m'' _ _ _ x1 ->
    x0 m' m'' x1 k e __ __)

(** val map_induction_bis :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> (('a1, 'a2) dict -> ('a1, 'a2)
    dict -> __ -> 'a3 -> 'a3) -> 'a3 -> ('a1 -> 'a2 -> ('a1, 'a2) dict -> __
    -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3 **)

let map_induction_bis hkey f x x0 x1 m =
  fold_rec_bis hkey f (fun x2 x3 x4 -> ()) () m (fun m0 m' a _ x2 ->
    x m0 m' __ x2) x0 (fun k e a m' _ _ x2 -> x1 k e m' __ x2)

(** val cardinal_inv_2 :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> int ->
    ('a1 * 'a2) **)

let cardinal_inv_2 hkey f m n =
  let l = elements hkey f m in
  (match l with
   | [] -> assert false (* absurd case *)
   | p :: l0 -> p)

(** val cardinal_inv_2b :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2) **)

let cardinal_inv_2b hkey f m =
  let n = fun x x0 -> cardinal x x0 in
  let x = fun x -> cardinal_inv_2 hkey f m x in
  ((fun fO fS n -> if n=0 then fO () else fS (n-1))
     (fun _ -> assert false
     (* absurd case *))
     (fun n0 ->
     x n0)
     (n hkey f m))

(** val filter :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> bool) -> ('a1, 'a2)
    dict -> ('a1, 'a2) dict **)

let filter hkey f f0 m =
  fold hkey f (fun k e m0 -> if f0 k e then add hkey f k e m0 else m0) m
    (empty hkey f)

(** val for_all :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> bool) -> ('a1, 'a2)
    dict -> bool **)

let for_all hkey f f0 m =
  fold hkey f (fun k e b -> if f0 k e then b else false) m true

(** val exists_ :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> bool) -> ('a1, 'a2)
    dict -> bool **)

let exists_ hkey f f0 m =
  fold hkey f (fun k e b -> if f0 k e then true else b) m false

(** val partition :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> bool) -> ('a1, 'a2)
    dict -> ('a1, 'a2) dict * ('a1, 'a2) dict **)

let partition hkey f f0 m =
  ((filter hkey f f0 m), (filter hkey f (fun k e -> negb (f0 k e)) m))

(** val update :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict **)

let update hkey f m1 m2 =
  fold hkey f (add hkey f) m2 m1

(** val restrict :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict **)

let restrict hkey f m1 m2 =
  filter hkey f (fun k x -> mem hkey f k m2) m1

(** val diff :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict **)

let diff hkey f m1 m2 =
  filter hkey f (fun k x -> negb (mem hkey f k m2)) m1

(** val coq_Partition_In :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict -> 'a1 -> bool **)

let coq_Partition_In hkey f m m1 m2 k =
  coq_In_dec hkey f m1 k

(** val update_dec :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> 'a1 -> 'a2 -> bool **)

let update_dec hkey f m m' k e =
  coq_In_dec hkey f m' k

(** val filter_dom :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> bool) -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict **)

let filter_dom hkey f f0 m =
  filter hkey f (fun k x -> f0 k) m

(** val filter_range :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> bool) -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict **)

let filter_range hkey f f0 m =
  filter hkey f (fun x -> f0) m

(** val for_all_dom :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> bool) -> ('a1, 'a2) dict
    -> bool **)

let for_all_dom hkey f f0 m =
  for_all hkey f (fun k x -> f0 k) m

(** val for_all_range :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> bool) -> ('a1, 'a2) dict
    -> bool **)

let for_all_range hkey f f0 m =
  for_all hkey f (fun x -> f0) m

(** val exists_dom :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> bool) -> ('a1, 'a2) dict
    -> bool **)

let exists_dom hkey f f0 m =
  exists_ hkey f (fun k x -> f0 k) m

(** val exists_range :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> bool) -> ('a1, 'a2) dict
    -> bool **)

let exists_range hkey f f0 m =
  exists_ hkey f (fun x -> f0) m

(** val partition_dom :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> bool) -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict * ('a1, 'a2) dict **)

let partition_dom hkey f f0 m =
  partition hkey f (fun k x -> f0 k) m

(** val partition_range :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> bool) -> ('a1, 'a2) dict
    -> ('a1, 'a2) dict * ('a1, 'a2) dict **)

let partition_range hkey f f0 m =
  partition hkey f (fun x -> f0) m

(** val gtb : 'a1 coq_OrderedType -> ('a1 * 'a2) -> ('a1 * 'a2) -> bool **)

let gtb hkey p p' =
  match compare hkey (fst p) (fst p') with
  | Gt -> true
  | _ -> false

(** val leb : 'a1 coq_OrderedType -> ('a1 * 'a2) -> ('a1 * 'a2) -> bool **)

let leb hkey p p' =
  negb (gtb hkey p p')

(** val elements_lt :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 * 'a2) -> ('a1, 'a2) dict ->
    ('a1 * 'a2) list **)

let elements_lt hkey f p m =
  List0.filter (gtb hkey p) (elements hkey f m)

(** val elements_ge :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 * 'a2) -> ('a1, 'a2) dict ->
    ('a1 * 'a2) list **)

let elements_ge hkey f p m =
  List0.filter (leb hkey p) (elements hkey f m)

(** val max_elt_aux : ('a1 * 'a2) list -> ('a1 * 'a2) option **)

let rec max_elt_aux = function
| [] -> None
| p :: l0 ->
  (match l0 with
   | [] -> Some p
   | p0 :: l1 -> max_elt_aux l0)

(** val max_elt :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2)
    option **)

let max_elt hkey f m =
  max_elt_aux (elements hkey f m)

(** val min_elt :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2)
    option **)

let min_elt hkey f m =
  match elements hkey f m with
  | [] -> None
  | p :: l -> let (x, e) = p in Some (x, e)

(** val map_induction_max :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> __ -> __ ->
    'a3) -> ('a1, 'a2) dict -> 'a3 **)

let map_induction_max hkey f x x0 m =
  let n = cardinal hkey f m in
  let rec f0 n0 m0 =
    (fun fO fS n -> if n=0 then fO () else fS (n-1))
      (fun _ ->
      x m0 __)
      (fun n1 ->
      match max_elt hkey f m0 with
      | Some p ->
        let (k, e) = p in
        x0 (remove hkey f k m0) m0 (f0 n1 (remove hkey f k m0)) k e __ __
      | None -> x m0 __)
      n0
  in f0 n m

(** val map_induction_min :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> __ -> __ ->
    'a3) -> ('a1, 'a2) dict -> 'a3 **)

let map_induction_min hkey f x x0 m =
  let n = cardinal hkey f m in
  let rec f0 n0 m0 =
    (fun fO fS n -> if n=0 then fO () else fS (n-1))
      (fun _ ->
      x m0 __)
      (fun n1 ->
      match min_elt hkey f m0 with
      | Some p ->
        let (k, e) = p in
        x0 (remove hkey f k m0) m0 (f0 n1 (remove hkey f k m0)) k e __ __
      | None -> x m0 __)
      n0
  in f0 n m

