open Datatypes
open List0
open OrderedType
open OrderedTypeEx

type __ = Obj.t

module MapList : 
 sig 
  type ('key, 'elt) dict = ('key * 'elt) list
  
  val empty : 'a1 coq_OrderedType -> ('a1, 'a2) dict
  
  val is_empty : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> bool
  
  val mem : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> bool
  
  type ('key, 'elt) coq_R_mem =
  | R_mem_0 of ('key, 'elt) dict
  | R_mem_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_mem_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_mem_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list * 
     bool * ('key, 'elt) coq_R_mem
  
  val coq_R_mem_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> bool -> ('a1,
    'a2) coq_R_mem -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> bool -> ('a1, 'a2)
    coq_R_mem -> 'a3
  
  val coq_R_mem_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> bool -> ('a1,
    'a2) coq_R_mem -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> bool -> ('a1, 'a2)
    coq_R_mem -> 'a3
  
  val mem_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) ->
    ('a1, 'a2) dict -> 'a3
  
  val mem_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) ->
    ('a1, 'a2) dict -> 'a3
  
  val coq_R_mem_correct :
    'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> bool -> ('a1, 'a2)
    coq_R_mem
  
  val find : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> 'a2 option
  
  type ('key, 'elt) coq_R_find =
  | R_find_0 of ('key, 'elt) dict
  | R_find_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_find_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_find_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * 'elt option * ('key, 'elt) coq_R_find
  
  val coq_R_find_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a2 option ->
    ('a1, 'a2) coq_R_find -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a2 option ->
    ('a1, 'a2) coq_R_find -> 'a3
  
  val coq_R_find_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a2 option ->
    ('a1, 'a2) coq_R_find -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a2 option ->
    ('a1, 'a2) coq_R_find -> 'a3
  
  val find_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) ->
    ('a1, 'a2) dict -> 'a3
  
  val find_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) ->
    ('a1, 'a2) dict -> 'a3
  
  val coq_R_find_correct :
    'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> 'a2 option -> ('a1, 'a2)
    coq_R_find
  
  val add :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) dict -> ('a1, 'a2) dict
  
  type ('key, 'elt) coq_R_add =
  | R_add_0 of ('key, 'elt) dict
  | R_add_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_add_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_add_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * ('key, 'elt) dict * ('key, 'elt) coq_R_add
  
  val coq_R_add_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> ('a1,
    'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) -> ('a1, 'a2) dict ->
    ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3
  
  val coq_R_add_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> ('a1,
    'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) -> ('a1, 'a2) dict ->
    ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3
  
  val add_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3 ->
    'a3) -> ('a1, 'a2) dict -> 'a3
  
  val add_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) ->
    (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3 ->
    'a3) -> ('a1, 'a2) dict -> 'a3
  
  val coq_R_add_correct :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) dict -> ('a1, 'a2) dict
    -> ('a1, 'a2) coq_R_add
  
  val remove :
    'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> ('a1, 'a2) dict
  
  type ('key, 'elt) coq_R_remove =
  | R_remove_0 of ('key, 'elt) dict
  | R_remove_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_remove_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_remove_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * ('key, 'elt) dict * ('key, 'elt) coq_R_remove
  
  val coq_R_remove_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> ('a1, 'a2)
    dict -> ('a1, 'a2) coq_R_remove -> 'a3 -> 'a3) -> ('a1, 'a2) dict ->
    ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3
  
  val coq_R_remove_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> ('a1, 'a2)
    dict -> ('a1, 'a2) coq_R_remove -> 'a3 -> 'a3) -> ('a1, 'a2) dict ->
    ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3
  
  val remove_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) ->
    ('a1, 'a2) dict -> 'a3
  
  val remove_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) ->
    ('a1, 'a2) dict -> 'a3
  
  val coq_R_remove_correct :
    'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1,
    'a2) coq_R_remove
  
  val insert :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) dict ->
    ('a1, 'a2) dict
  
  type ('key, 'elt) coq_R_insert =
  | R_insert_0 of ('key, 'elt) dict
  | R_insert_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_insert_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_insert_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * ('key, 'elt) dict * ('key, 'elt) coq_R_insert
  
  val coq_R_insert_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert -> 'a3 -> 'a3) -> ('a1,
    'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert -> 'a3
  
  val coq_R_insert_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert -> 'a3 -> 'a3) -> ('a1,
    'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert -> 'a3
  
  val insert_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
  
  val insert_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
  
  val coq_R_insert_correct :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) dict ->
    ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert
  
  val adjust :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) dict -> ('a1,
    'a2) dict
  
  type ('key, 'elt) coq_R_adjust =
  | R_adjust_0 of ('key, 'elt) dict
  | R_adjust_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_adjust_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
  | R_adjust_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
     * ('key, 'elt) dict * ('key, 'elt) coq_R_adjust
  
  val coq_R_adjust_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> ('a1, 'a2)
    dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3
  
  val coq_R_adjust_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> ('a1, 'a2)
    dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3
  
  val adjust_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
  
  val adjust_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
    'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
  
  val coq_R_adjust_correct :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) dict -> ('a1,
    'a2) dict -> ('a1, 'a2) coq_R_adjust
  
  val elements : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1, 'a2) dict
  
  val cardinal : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> int
  
  val choose : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1 * 'a2) option
  
  val fold :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) dict ->
    'a3 -> 'a3
  
  type ('key, 'elt, 'a) coq_R_fold =
  | R_fold_0 of ('key, 'elt) dict * 'a
  | R_fold_1 of ('key, 'elt) dict * 'a * 'key * 'elt * ('key * 'elt) list
     * 'a * ('key, 'elt, 'a) coq_R_fold
  
  val coq_R_fold_rect :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict ->
    'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> ('a1 * 'a2)
    list -> __ -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4 -> 'a4) -> ('a1,
    'a2) dict -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4
  
  val coq_R_fold_rec :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict ->
    'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> ('a1 * 'a2)
    list -> __ -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4 -> 'a4) -> ('a1,
    'a2) dict -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4
  
  val fold_rect :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict ->
    'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> ('a1 * 'a2)
    list -> __ -> 'a4 -> 'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a4
  
  val fold_rec :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict ->
    'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 -> ('a1 * 'a2)
    list -> __ -> 'a4 -> 'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a4
  
  val coq_R_fold_correct :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) dict ->
    'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold
  
  val equal :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) dict -> ('a1,
    'a2) dict -> bool
  
  type ('key, 'elt) coq_R_equal =
  | R_equal_0 of ('key, 'elt) dict * ('key, 'elt) dict
  | R_equal_1 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
     * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list * bool
     * ('key, 'elt) coq_R_equal
  | R_equal_2 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
     * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list
  | R_equal_3 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
     * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list * comparison
  | R_equal_4 of ('key, 'elt) dict * ('key, 'elt) dict * ('key, 'elt) dict
     * ('key, 'elt) dict
  
  val coq_R_equal_rect :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict -> ('a1,
    'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict ->
    'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
    __ -> __ -> __ -> bool -> ('a1, 'a2) coq_R_equal -> 'a3 -> 'a3) -> (('a1,
    'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2)
    dict -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
    'a2 -> ('a1 * 'a2) list -> __ -> comparison -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict
    -> __ -> __ -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool ->
    ('a1, 'a2) coq_R_equal -> 'a3
  
  val coq_R_equal_rec :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict -> ('a1,
    'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict ->
    'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
    __ -> __ -> __ -> bool -> ('a1, 'a2) coq_R_equal -> 'a3 -> 'a3) -> (('a1,
    'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2)
    dict -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
    'a2 -> ('a1 * 'a2) list -> __ -> comparison -> __ -> __ -> 'a3) -> (('a1,
    'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict
    -> __ -> __ -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool ->
    ('a1, 'a2) coq_R_equal -> 'a3
  
  val equal_rect :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict -> ('a1,
    'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict ->
    'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
    __ -> __ -> __ -> 'a3 -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict ->
    'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
    __ -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 ->
    'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    comparison -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict ->
    ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict -> __ -> __ -> 'a3) -> ('a1,
    'a2) dict -> ('a1, 'a2) dict -> 'a3
  
  val equal_rec :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict -> ('a1,
    'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict ->
    'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
    __ -> __ -> __ -> 'a3 -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict ->
    'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
    __ -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 ->
    'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
    comparison -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict ->
    ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict -> __ -> __ -> 'a3) -> ('a1,
    'a2) dict -> ('a1, 'a2) dict -> 'a3
  
  val coq_R_equal_correct :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) dict -> ('a1,
    'a2) dict -> bool -> ('a1, 'a2) coq_R_equal
  
  val map :
    'a1 coq_OrderedType -> ('a2 -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a3) dict
  
  val mapi :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) dict -> ('a1,
    'a3) dict
  
  val option_cons : 'a1 -> 'a2 option -> ('a1 * 'a2) list -> ('a1 * 'a2) list
  
  val map2_l :
    'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) -> ('a1,
    'a2) dict -> ('a1, 'a4) dict
  
  val map2_r :
    'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) -> ('a1,
    'a3) dict -> ('a1, 'a4) dict
  
  val map2 :
    'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) -> ('a1,
    'a2) dict -> ('a1, 'a3) dict -> ('a1, 'a4) dict
  
  val map_OrderedType :
    'a1 coq_OrderedType -> ('a1, 'a2) dict coq_OrderedType
  
  module K : 
   sig 
    
   end
  
  val combine :
    'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1, 'a2
    option * 'a3 option) dict
  
  val fold_right_pair :
    ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3
  
  val map2_alt :
    'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) -> ('a1,
    'a2) dict -> ('a1, 'a3) dict -> ('a1 * 'a4) list
  
  val at_least_one :
    'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option
  
  val at_least_one_then_f :
    ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2 option ->
    'a3 option
 end

