open BinInt
open Datatypes
open DomAbsMem
open DomAbsValue
open DomAcc
open DomBasic
open DomBridge
open DomItv
open DomMap
open DomSet
open DomType
open List0
open MapAVLInstance
open MapInterface
open SetAVLInstance
open SetInterface
open Syntax
open ZArith_dec

(** val range_of : ctype -> itvT option **)

let range_of = function
| Coq_typ_uint ->
  Some (Some (Coq_itv'_z_z (0, ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) 1))))))))))))))))))))))))))))))))))
| Coq_typ_uchar ->
  Some (Some (Coq_itv'_z_z (0, ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) 1))))))))))
| Coq_typ_ushort ->
  Some (Some (Coq_itv'_z_z (0, ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) 1))))))))))))))))))
| Coq_typ_ulong ->
  Some (Some (Coq_itv'_z_z (0, ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) 1))))))))))))))))))))))))))))))))))
| Coq_typ_int ->
  Some (Some (Coq_itv'_z_z (((~-) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    1)))))))))))))))))))))))))))))))), ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    1)))))))))))))))))))))))))))))))))
| Coq_typ_char ->
  Some (Some (Coq_itv'_z_z (((~-) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) 1)))))))),
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) 1)))))))))
| Coq_typ_short ->
  Some (Some (Coq_itv'_z_z (((~-) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) 1)))))))))))))))), ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) 1)))))))))))))))))
| Coq_typ_long ->
  Some (Some (Coq_itv'_z_z (((~-) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    ((fun p->2*p) ((fun p->2*p) ((fun p->2*p)
    1)))))))))))))))))))))))))))))))), ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p) ((fun p->1+2*p)
    1)))))))))))))))))))))))))))))))))
| x -> None

(** val ctype_stride_of : ctype -> int option **)

let ctype_stride_of = function
| Coq_typ_uint -> Some ((fun p->2*p) ((fun p->2*p) 1))
| Coq_typ_uchar -> Some 1
| Coq_typ_ushort -> Some ((fun p->2*p) 1)
| Coq_typ_ulong -> Some ((fun p->2*p) ((fun p->2*p) 1))
| Coq_typ_ulonglong -> Some ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) 1)))
| Coq_typ_int -> Some ((fun p->2*p) ((fun p->2*p) 1))
| Coq_typ_char -> Some 1
| Coq_typ_short -> Some ((fun p->2*p) 1)
| Coq_typ_long -> Some ((fun p->2*p) ((fun p->2*p) 1))
| Coq_typ_longlong -> Some ((fun p->2*p) ((fun p->2*p) ((fun p->2*p) 1)))
| Coq_typ_pointer t -> Some ((fun p->2*p) ((fun p->2*p) 1))
| _ -> None

(** val itv_cast : ctype -> itvT -> itvT **)

let itv_cast ct itv =
  let range = range_of ct in
  (match range with
   | Some r ->
     if leb (option_setoid itvT'_setoid)
          (option_poset itvT'_setoid itvT'_poset)
          (option_setoidDec itvT'_setoid itvT'_setoidDec)
          (option_posetDec itvT'_setoid itvT'_poset itvT'_setoidDec
            itvT'_posetDec) itv r
     then itv
     else r
   | None ->
     top (option_setoid itvT'_setoid) (option_poset itvT'_setoid itvT'_poset)
       (option_hasTop itvT'_setoid itvT'_poset itvT'_hasTop))

(** val itv_const : int -> itvT **)

let itv_const z =
  Some (Coq_itv'_z_z (z, z))

(** val arrv_cast : ctype -> arrvT -> arrvT **)

let arrv_cast ct arrv = match arrv with
| Elt av ->
  (match ct with
   | Coq_typ_pointer pt ->
     (match ctype_stride_of pt with
      | Some st ->
        let newStride = itv_const st in
        Elt
        (map
          (order_OrderedType positive_setoid positive_poset
            positive_setoidDec positive_posetDec)
          (coq_MapAVL_FMap
            (order_OrderedType positive_setoid positive_poset
              positive_setoidDec positive_posetDec)) (fun v ->
          if eqb
               (pair_setoid
                 (pair_setoid (option_setoid itvT'_setoid)
                   (option_setoid itvT'_setoid))
                 (option_setoid itvT'_setoid))
               (pair_setoidDec
                 (pair_setoid (option_setoid itvT'_setoid)
                   (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid)
                 (pair_setoidDec (option_setoid itvT'_setoid)
                   (option_setoid itvT'_setoid)
                   (option_setoidDec itvT'_setoid itvT'_setoidDec)
                   (option_setoidDec itvT'_setoid itvT'_setoidDec))
                 (option_setoidDec itvT'_setoid itvT'_setoidDec)) v
               (bot
                 (pair_setoid
                   (pair_setoid (option_setoid itvT'_setoid)
                     (option_setoid itvT'_setoid))
                   (option_setoid itvT'_setoid)) ossT_poset ossT_hasBot)
          then v
          else let (y, stride) = v in
               let (os, size) = y in
               (((op_div (op_mul os stride) newStride),
               (op_div (op_mul size stride) newStride)), newStride)) av)
      | None -> arrv)
   | _ -> arrv)
| Top ->
  top
    (withtop_setoid
      (map_setoid positive_setoid positive_poset positive_setoidDec
        positive_posetDec
        (pair_setoid
          (pair_setoid (option_setoid itvT'_setoid)
            (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
        ossT_poset ossT_hasBot)) arrvT_poset
    (withtop_hasTop
      (map_setoid positive_setoid positive_poset positive_setoidDec
        positive_posetDec
        (pair_setoid
          (pair_setoid (option_setoid itvT'_setoid)
            (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
        ossT_poset ossT_hasBot)
      (map_poset positive_setoid positive_poset positive_setoidDec
        positive_posetDec
        (pair_setoid
          (pair_setoid (option_setoid itvT'_setoid)
            (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
        ossT_poset ossT_hasBot))

(** val cast : ctype -> valueT -> valueT **)

let cast ct = function
| (p, arrv) ->
  let (itv, l) = p in
  (((itv_cast ct itv),
  (bot
    (withtop_setoid
      (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
    (withtop_poset
      (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
      (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec))
    (withtop_hasBot
      (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
      (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec)
      (set_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec)))),
  (arrv_cast ct arrv))

(** val append_field : idT -> (locT, locT) morphism **)

let append_field f loc =
  ((fst loc), (f :: (snd loc)))

(** val sem_expr : fidT -> exprT -> memT -> valueT **)

let rec sem_expr fid e mem =
  match e with
  | Coq_expr_const lit ->
    (match lit with
     | Coq_lit_int z -> vconst z
     | Coq_lit_int_top ->
       (((top (option_setoid itvT'_setoid)
           (option_poset itvT'_setoid itvT'_poset)
           (option_hasTop itvT'_setoid itvT'_poset itvT'_hasTop)),
         (bot
           (withtop_setoid
             (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
           (withtop_poset
             (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
             (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec))
           (withtop_hasBot
             (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
             (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec)
             (set_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec)))),
         (bot
           (withtop_setoid
             (map_setoid positive_setoid positive_poset positive_setoidDec
               positive_posetDec
               (pair_setoid
                 (pair_setoid (option_setoid itvT'_setoid)
                   (option_setoid itvT'_setoid))
                 (option_setoid itvT'_setoid)) ossT_poset ossT_hasBot))
           arrvT_poset arrvT_hasBot))
     | Coq_lit_top -> top valueT_setoid valueT_poset valueT_hasTop
     | Coq_lit_bot -> bot valueT_setoid valueT_poset valueT_hasBot)
  | Coq_expr_op2 (op, lhs, rhs) ->
    vop2 op (sem_expr fid lhs mem) (sem_expr fid rhs mem)
  | Coq_expr_op1 (op, e') -> vop1 op (sem_expr fid e' mem)
  | Coq_expr_value_of l -> memory_lookup (sem_expr_lv fid l mem) mem
  | Coq_expr_addr_of l ->
    (((bot (option_setoid itvT'_setoid)
        (option_poset itvT'_setoid itvT'_poset)
        (option_hasBot itvT'_setoid itvT'_poset)), (sem_expr_lv fid l mem)),
      (bot
        (withtop_setoid
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot)) arrvT_poset arrvT_hasBot))
  | Coq_expr_cast (ct, ce) -> cast ct (sem_expr fid ce mem)
  | Coq_expr_size_of e0 ->
    (((top (option_setoid itvT'_setoid)
        (option_poset itvT'_setoid itvT'_poset)
        (option_hasTop itvT'_setoid itvT'_poset itvT'_hasTop)),
      (bot
        (withtop_setoid
          (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
        (withtop_poset
          (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
          (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec))
        (withtop_hasBot
          (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
          (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec)
          (set_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec)))),
      (bot
        (withtop_setoid
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot)) arrvT_poset arrvT_hasBot))

(** val sem_expr_lv : fidT -> lv -> memT -> locsT **)

and sem_expr_lv fid l mem =
  match l with
  | Coq_lv_id x ->
    Elt
      ((coq_SetAVL_FSet
         (order_OrderedType locT_setoid locT_poset locT_setoidDec
           locT_posetDec)).singleton (var_loc fid x []))
  | Coq_lv_deref e ->
    let v = sem_expr fid e mem in
    join
      (withtop_setoid
        (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
      (withtop_poset
        (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
        (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec))
      (withtop_hasJoin
        (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
        (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec)
        (set_hasJoin locT_setoid locT_poset locT_setoidDec locT_posetDec))
      (locs_of v) (locs_from_arrvT (arrv_of v))
  | Coq_lv_array (e, idx) ->
    let v = sem_expr fid e mem in locs_from_arrvT (arrv_of v)
  | Coq_lv_struct (l0, pos) ->
    let locs = sem_expr_lv fid l0 mem in
    (match locs with
     | Elt locs' ->
       Elt
         (DomSet.map locT_setoid locT_poset locT_setoidDec locT_posetDec
           (append_field pos) locs')
     | Top ->
       top
         (withtop_setoid
           (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
         (withtop_poset
           (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
           (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec))
         (withtop_hasTop
           (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
           (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec)))

(** val sem_exprs : fidT -> exprT list -> memT -> valueT list **)

let rec sem_exprs fid exprs mem =
  match exprs with
  | [] -> []
  | istr :: exprs' -> (sem_expr fid istr mem) :: (sem_exprs fid exprs' mem)

(** val itv_restrict_ub : itvT -> int -> itvT' option **)

let itv_restrict_ub x ub =
  match x with
  | Some x' ->
    (match x' with
     | Coq_itv'_top -> Some (Coq_itv'_inf_z ub)
     | Coq_itv'_inf_z ux -> Some (Coq_itv'_inf_z (Z.min ux ub))
     | Coq_itv'_z_inf lx ->
       if coq_Z_le_dec lx ub then Some (Coq_itv'_z_z (lx, ub)) else None
     | Coq_itv'_z_z (lx, ux) ->
       if coq_Z_le_dec lx ub
       then Some (Coq_itv'_z_z (lx, (Z.min ux ub)))
       else None)
  | None -> None

(** val itv_restrict_lb : itvT -> int -> itvT' option **)

let itv_restrict_lb x lb =
  match x with
  | Some x' ->
    (match x' with
     | Coq_itv'_top -> Some (Coq_itv'_z_inf lb)
     | Coq_itv'_inf_z ux ->
       if coq_Z_le_dec lb ux then Some (Coq_itv'_z_z (lb, ux)) else None
     | Coq_itv'_z_inf lx -> Some (Coq_itv'_z_inf (Z.max lx lb))
     | Coq_itv'_z_z (lx, ux) ->
       if coq_Z_le_dec lb ux
       then Some (Coq_itv'_z_z ((Z.max lx lb), ux))
       else None)
  | None -> None

(** val adjust_inter_lt : itvT -> itvT -> itvT **)

let adjust_inter_lt x = function
| Some y' ->
  (match y' with
   | Coq_itv'_inf_z uy -> itv_restrict_ub x (Z.sub uy 1)
   | Coq_itv'_z_z (l, uy) -> itv_restrict_ub x (Z.sub uy 1)
   | _ -> x)
| None -> None

(** val adjust_inter_le : itvT -> itvT -> itvT **)

let adjust_inter_le x = function
| Some y' ->
  (match y' with
   | Coq_itv'_inf_z uy -> itv_restrict_ub x uy
   | Coq_itv'_z_z (l, uy) -> itv_restrict_ub x uy
   | _ -> x)
| None -> None

(** val adjust_inter_gt : itvT -> itvT -> itvT **)

let adjust_inter_gt x = function
| Some y' ->
  (match y' with
   | Coq_itv'_z_inf ly -> itv_restrict_lb x (Z.add ly 1)
   | Coq_itv'_z_z (ly, u) -> itv_restrict_lb x (Z.add ly 1)
   | _ -> x)
| None -> None

(** val adjust_inter_ge : itvT -> itvT -> itvT **)

let adjust_inter_ge x = function
| Some y' ->
  (match y' with
   | Coq_itv'_z_inf ly -> itv_restrict_lb x ly
   | Coq_itv'_z_z (ly, u) -> itv_restrict_lb x ly
   | _ -> x)
| None -> None

(** val adjust_inter_eq : itvT -> itvT -> itvT **)

let adjust_inter_eq x y =
  adjust_inter_le (adjust_inter_ge x y) y

(** val adjust_inter_neq : itvT -> itvT -> itvT **)

let adjust_inter_neq x y =
  join (option_setoid itvT'_setoid) (option_poset itvT'_setoid itvT'_poset)
    (option_hasJoin itvT'_setoid itvT'_poset itvT'_hasJoin)
    (adjust_inter_lt x y) (adjust_inter_gt x y)

(** val adjust_inter : itvT -> op2 -> itvT -> itvT **)

let adjust_inter x o y =
  match o with
  | Coq_op_lt -> adjust_inter_lt x y
  | Coq_op_le -> adjust_inter_le x y
  | Coq_op_gt -> adjust_inter_gt x y
  | Coq_op_ge -> adjust_inter_ge x y
  | Coq_op_eq -> adjust_inter_eq x y
  | Coq_op_neq -> adjust_inter_neq x y
  | _ -> x

(** val adjust_loc_eq : locsT -> locsT -> locT set withtop **)

let adjust_loc_eq x y = match y with
| Elt y' ->
  (match x with
   | Elt x' ->
     Elt
       ((coq_SetAVL_FSet
          (order_OrderedType locT_setoid locT_poset locT_setoidDec
            locT_posetDec)).inter x' y')
   | Top -> y)
| Top -> x

(** val adjust_loc : locsT -> op2 -> locsT -> locsT **)

let adjust_loc x o y =
  match o with
  | Coq_op_eq -> adjust_loc_eq x y
  | _ -> x

(** val adjust_val : valueT -> op2 -> valueT -> (itvT * locsT) * arrvT **)

let adjust_val x o y =
  let (p, rx) = x in
  let (ix, lx) = p in
  let (p0, ry) = y in
  let (iy, ly) = p0 in (((adjust_inter ix o iy), (adjust_loc lx o ly)), rx)

(** val adjust : accT -> locsT -> op2 -> valueT -> memT -> memT **)

let adjust acc a b v m =
  let av = memory_lookup a m in memory_update acc a (adjust_val av b v) m

(** val prune_bop : accT -> fidT -> exprT -> memT -> memT **)

let prune_bop acc fid e m =
  match e with
  | Coq_expr_op2 (o, lhs, e2) ->
    (match lhs with
     | Coq_expr_value_of l ->
       (match l with
        | Coq_lv_id x ->
          let locx = var_loc fid x [] in
          if is_strong acc locx
          then adjust acc (sem_expr_lv fid (Coq_lv_id x) m) o
                 (sem_expr fid e2 m) m
          else m
        | _ -> m)
     | _ -> m)
  | _ -> m

(** val remove_uop : exprT -> exprT option **)

let rec remove_uop = function
| Coq_expr_op2 (op, e1, e2) ->
  (match op with
   | Coq_op_lt -> Some (Coq_expr_op2 (Coq_op_lt, e1, e2))
   | Coq_op_le -> Some (Coq_expr_op2 (Coq_op_le, e1, e2))
   | Coq_op_gt -> Some (Coq_expr_op2 (Coq_op_gt, e1, e2))
   | Coq_op_ge -> Some (Coq_expr_op2 (Coq_op_ge, e1, e2))
   | Coq_op_eq -> Some (Coq_expr_op2 (Coq_op_eq, e1, e2))
   | Coq_op_neq -> Some (Coq_expr_op2 (Coq_op_neq, e1, e2))
   | _ -> None)
| Coq_expr_op1 (op, e0) ->
  (match op with
   | Coq_op_not ->
     (match e0 with
      | Coq_expr_op2 (op0, e1, e2) ->
        (match op0 with
         | Coq_op_lt -> Some (Coq_expr_op2 (Coq_op_ge, e1, e2))
         | Coq_op_le -> Some (Coq_expr_op2 (Coq_op_gt, e1, e2))
         | Coq_op_gt -> Some (Coq_expr_op2 (Coq_op_le, e1, e2))
         | Coq_op_ge -> Some (Coq_expr_op2 (Coq_op_lt, e1, e2))
         | Coq_op_eq -> Some (Coq_expr_op2 (Coq_op_neq, e1, e2))
         | Coq_op_neq -> Some (Coq_expr_op2 (Coq_op_eq, e1, e2))
         | _ -> None)
      | Coq_expr_op1 (op0, e1) ->
        (match op0 with
         | Coq_op_not -> remove_uop e1
         | Coq_op_bnot -> None)
      | _ -> None)
   | Coq_op_bnot -> None)
| _ -> None

(** val memory_prune : accT -> fidT -> exprT -> memT -> memT **)

let memory_prune acc fid e m =
  let v = sem_expr fid e m in
  if leb (option_setoid itvT'_setoid) (option_poset itvT'_setoid itvT'_poset)
       (option_setoidDec itvT'_setoid itvT'_setoidDec)
       (option_posetDec itvT'_setoid itvT'_poset itvT'_setoidDec
         itvT'_posetDec) (itv_of v) (Some (Coq_itv'_z_z (0, 0)))
  then bot memT_setoid memT_poset
         (withtop_hasBot
           (map_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec
             valueT_setoid valueT_poset valueT_hasBot)
           (map_poset locT_setoid locT_poset locT_setoidDec locT_posetDec
             valueT_setoid valueT_poset valueT_hasBot)
           (map_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec
             valueT_setoid valueT_poset valueT_hasBot))
  else let filtered_var = remove_uop e in
       (match filtered_var with
        | Some e' -> prune_bop acc fid e' m
        | None -> m)

(** val libcall :
    accT -> fidT -> allocT -> lv option -> lcall -> exprT list -> memT ->
    memT **)

let libcall acc fid site ret lid args mem =
  match lid with
  | Coq_rand ->
    (match ret with
     | Some retlv ->
       let retlocs = sem_expr_lv fid retlv mem in
       let rand = itv_to_valueT (Some (Coq_itv'_z_inf 0)) in
       memory_update acc retlocs rand mem
     | None -> mem)
  | Coq_strlen ->
    (match ret with
     | Some retlv ->
       let retlocs = sem_expr_lv fid retlv mem in
       let length = itv_to_valueT (Some (Coq_itv'_z_inf 0)) in
       memory_update acc retlocs length mem
     | None -> mem)
  | Coq_strcpy ->
    let dstLocs = sem_expr fid (hd (Coq_expr_const Coq_lit_bot) args) mem in
    let dst = locs_of dstLocs in
    let srcLocs =
      sem_expr fid (hd (Coq_expr_const Coq_lit_bot) (tl args)) mem
    in
    let src = locs_of srcLocs in
    let srcValue = memory_lookup src mem in
    let newMem = memory_update acc dst srcValue mem in
    (match ret with
     | Some retlv ->
       let retlocs = sem_expr_lv fid retlv newMem in
       memory_update acc retlocs (locs_to_valueT dst) newMem
     | None -> newMem)
  | Coq_scanf ->
    let addrs = List0.map (fun e -> locs_of (sem_expr fid e mem)) args in
    fold_right (fun locs m ->
      memory_update acc locs
        (((top (option_setoid itvT'_setoid)
            (option_poset itvT'_setoid itvT'_poset)
            (option_hasTop itvT'_setoid itvT'_poset itvT'_hasTop)),
        (bot
          (withtop_setoid
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
          (withtop_poset
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec))
          (withtop_hasBot
            (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec)
            (set_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec)))),
        (bot
          (withtop_setoid
            (map_setoid positive_setoid positive_poset positive_setoidDec
              positive_posetDec
              (pair_setoid
                (pair_setoid (option_setoid itvT'_setoid)
                  (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
              ossT_poset ossT_hasBot)) arrvT_poset arrvT_hasBot)) m) mem
      addrs
  | Coq_errno_location ->
    (match ret with
     | Some retlv ->
       let retlocs = sem_expr_lv fid retlv mem in
       let elt = (((itv_const 0), (itv_const 1)),
         (itv_const ((fun p->2*p) ((fun p->2*p) 1))))
       in
       let singleton0 =
         MapInterface.add
           (order_OrderedType positive_setoid positive_poset
             positive_setoidDec positive_posetDec)
           (coq_MapAVL_FMap
             (order_OrderedType positive_setoid positive_poset
               positive_setoidDec positive_posetDec)) site elt
           (bot
             (map_setoid positive_setoid positive_poset positive_setoidDec
               positive_posetDec
               (pair_setoid
                 (pair_setoid (option_setoid itvT'_setoid)
                   (option_setoid itvT'_setoid))
                 (option_setoid itvT'_setoid)) ossT_poset ossT_hasBot)
             arrvT'_poset arrvT'_hasBot)
       in
       memory_update acc retlocs (arrv_to_valueT (Elt singleton0)) mem
     | None -> mem)
  | Coq_builtin_alloca ->
    (match ret with
     | Some retlv ->
       let retlocs = sem_expr_lv fid retlv mem in
       let allocSize =
         itv_of (sem_expr fid (hd (Coq_expr_const Coq_lit_bot) args) mem)
       in
       let elt = (((itv_const 0), allocSize), (itv_const 1)) in
       let singleton0 =
         MapInterface.add
           (order_OrderedType positive_setoid positive_poset
             positive_setoidDec positive_posetDec)
           (coq_MapAVL_FMap
             (order_OrderedType positive_setoid positive_poset
               positive_setoidDec positive_posetDec)) site elt
           (bot
             (map_setoid positive_setoid positive_poset positive_setoidDec
               positive_posetDec
               (pair_setoid
                 (pair_setoid (option_setoid itvT'_setoid)
                   (option_setoid itvT'_setoid))
                 (option_setoid itvT'_setoid)) ossT_poset ossT_hasBot)
             arrvT'_poset arrvT'_hasBot)
       in
       memory_update acc retlocs (arrv_to_valueT (Elt singleton0)) mem
     | None -> mem)
  | Coq_builtin_choose_expr ->
    (match ret with
     | Some retlv ->
       let retlocs = sem_expr_lv fid retlv mem in
       let cond =
         itv_of (sem_expr fid (hd (Coq_expr_const Coq_lit_bot) args) mem)
       in
       let v1 = sem_expr fid (hd (Coq_expr_const Coq_lit_bot) (tl args)) mem
       in
       let v2 =
         sem_expr fid (hd (Coq_expr_const Coq_lit_bot) (tl (tl args))) mem
       in
       if eqb (option_setoid itvT'_setoid)
            (option_setoidDec itvT'_setoid itvT'_setoidDec) cond
            (itv_const 0)
       then memory_update acc retlocs v2 mem
       else if leb (option_setoid itvT'_setoid)
                 (option_poset itvT'_setoid itvT'_poset)
                 (option_setoidDec itvT'_setoid itvT'_setoidDec)
                 (option_posetDec itvT'_setoid itvT'_poset itvT'_setoidDec
                   itvT'_posetDec) (itv_const 0) cond
            then memory_update acc retlocs
                   (join valueT_setoid valueT_poset valueT_hasJoin v1 v2) mem
            else memory_update acc retlocs v1 mem
     | None -> mem)
  | _ -> mem

(** val sem_instr : accT -> fidT -> instrT -> memT -> memT **)

let sem_instr acc fid istr mem =
  match istr with
  | Coq_instr_assign (x, e) ->
    let locs = sem_expr_lv fid x mem in
    memory_update acc locs (sem_expr fid e mem) mem
  | Coq_instr_alloc (l, a, site) ->
    let locs = sem_expr_lv fid l mem in
    let Coq_alloc_arr (ve, ste) = a in
    let val0 = sem_expr fid ve mem in
    let st = sem_expr fid ste mem in
    let oss = (((itv_const 0), (itv_of val0)), (itv_of st)) in
    memory_update acc locs (((itv_const 0),
      (bot
        (withtop_setoid
          (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec))
        (withtop_poset
          (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
          (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec))
        (withtop_hasBot
          (set_setoid locT_setoid locT_poset locT_setoidDec locT_posetDec)
          (set_poset locT_setoid locT_poset locT_setoidDec locT_posetDec)
          (set_hasBot locT_setoid locT_poset locT_setoidDec locT_posetDec)))),
      (Elt
      ((map_maplike positive_setoid positive_poset positive_setoidDec
         positive_posetDec
         (pair_setoid
           (pair_setoid (option_setoid itvT'_setoid)
             (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
         ossT_poset ossT_hasBot).madd site oss
        (bot
          (map_setoid positive_setoid positive_poset positive_setoidDec
            positive_posetDec
            (pair_setoid
              (pair_setoid (option_setoid itvT'_setoid)
                (option_setoid itvT'_setoid)) (option_setoid itvT'_setoid))
            ossT_poset ossT_hasBot) arrvT'_poset arrvT'_hasBot)))) mem
  | Coq_instr_assume tst -> memory_prune acc fid tst mem
  | Coq_instr_libcall (ret, lid, args, site) ->
    libcall acc fid site ret lid args mem
  | Coq_instr_forget aloc -> memT_maplike.mremove aloc mem
  | Coq_instr_skip -> mem

(** val sem_instrs : accT -> fidT -> instrT list -> memT -> memT **)

let rec sem_instrs acc fid instrs mem =
  match instrs with
  | [] -> mem
  | istr :: instrs' ->
    sem_instrs acc fid instrs' (sem_instr acc fid istr mem)

(** val sem_bind_params :
    accT -> fidT -> valueT list -> idT list -> memT -> memT **)

let rec sem_bind_params acc fid args params mem =
  match args with
  | [] -> mem
  | arg :: args' ->
    (match params with
     | [] -> mem
     | param :: params' ->
       sem_bind_params acc fid args' params'
         (memory_update acc (Elt
           ((set_setlike locT_setoid locT_poset locT_setoidDec locT_posetDec).ssingleton
             (var_loc fid (local param) []))) arg mem))

(** val sem_bind_ret :
    accT -> fidT -> valueT -> varT option -> memT -> memT **)

let sem_bind_ret acc fid result retto mem =
  match retto with
  | Some retto' ->
    memory_update acc (Elt
      ((set_setlike locT_setoid locT_poset locT_setoidDec locT_posetDec).ssingleton
        (var_loc fid retto' []))) result mem
  | None -> mem

