open BinInt
open Datatypes
open DomAbsMem
open DomAbsValue
open DomAcc
open DomBasic
open DomBridge
open DomItv
open DomMap
open DomSet
open DomType
open List0
open MapAVLInstance
open MapInterface
open SetAVLInstance
open SetInterface
open Syntax
open ZArith_dec

val range_of : ctype -> itvT option

val ctype_stride_of : ctype -> int option

val itv_cast : ctype -> itvT -> itvT

val itv_const : int -> itvT

val arrv_cast : ctype -> arrvT -> arrvT

val cast : ctype -> valueT -> valueT

val append_field : idT -> (locT, locT) morphism

val sem_expr : fidT -> exprT -> memT -> valueT

val sem_expr_lv : fidT -> lv -> memT -> locsT

val sem_exprs : fidT -> exprT list -> memT -> valueT list

val itv_restrict_ub : itvT -> int -> itvT' option

val itv_restrict_lb : itvT -> int -> itvT' option

val adjust_inter_lt : itvT -> itvT -> itvT

val adjust_inter_le : itvT -> itvT -> itvT

val adjust_inter_gt : itvT -> itvT -> itvT

val adjust_inter_ge : itvT -> itvT -> itvT

val adjust_inter_eq : itvT -> itvT -> itvT

val adjust_inter_neq : itvT -> itvT -> itvT

val adjust_inter : itvT -> op2 -> itvT -> itvT

val adjust_loc_eq : locsT -> locsT -> locT set withtop

val adjust_loc : locsT -> op2 -> locsT -> locsT

val adjust_val : valueT -> op2 -> valueT -> (itvT * locsT) * arrvT

val adjust : accT -> locsT -> op2 -> valueT -> memT -> memT

val prune_bop : accT -> fidT -> exprT -> memT -> memT

val remove_uop : exprT -> exprT option

val memory_prune : accT -> fidT -> exprT -> memT -> memT

val libcall :
  accT -> fidT -> allocT -> lv option -> lcall -> exprT list -> memT -> memT

val sem_instr : accT -> fidT -> instrT -> memT -> memT

val sem_instrs : accT -> fidT -> instrT list -> memT -> memT

val sem_bind_params : accT -> fidT -> valueT list -> idT list -> memT -> memT

val sem_bind_ret : accT -> fidT -> valueT -> varT option -> memT -> memT

