open BinInt
open Datatypes
open OrderedType
open Peano
open ZArith_dec

type __ = Obj.t

module MapAVL : 
 sig 
  type ('key, 'elt) tree =
  | Leaf
  | Node of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  
  val tree_rect :
    'a3 -> (('a1, 'a2) tree -> 'a3 -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> 'a3 ->
    int -> 'a3) -> ('a1, 'a2) tree -> 'a3
  
  val tree_rec :
    'a3 -> (('a1, 'a2) tree -> 'a3 -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> 'a3 ->
    int -> 'a3) -> ('a1, 'a2) tree -> 'a3
  
  val height : ('a1, 'a2) tree -> int
  
  val cardinal : ('a1, 'a2) tree -> int
  
  val empty : ('a1, 'a2) tree
  
  val is_empty : ('a1, 'a2) tree -> bool
  
  val mem : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) tree -> bool
  
  type ('key, 'elt) coq_R_mem =
  | R_mem_0 of ('key, 'elt) tree
  | R_mem_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_mem_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * bool * ('key, 'elt) coq_R_mem
  | R_mem_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * bool * ('key, 'elt) coq_R_mem
  
  val coq_R_mem_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
    -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3 ->
    'a3) -> ('a1, 'a2) tree -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
  
  val coq_R_mem_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
    -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3 ->
    'a3) -> ('a1, 'a2) tree -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
  
  val find : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) tree -> 'a2 option
  
  type ('key, 'elt) coq_R_find =
  | R_find_0 of ('key, 'elt) tree
  | R_find_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_find_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * 'elt option * ('key, 'elt) coq_R_find
  | R_find_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * 'elt option * ('key, 'elt) coq_R_find
  
  val coq_R_find_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3
  
  val coq_R_find_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3
  
  val create :
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  val assert_false :
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  val bal :
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_bal =
  | R_bal_0 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
  | R_bal_1 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_2 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_3 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_4 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
  | R_bal_5 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_6 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_7 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_8 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
  
  val coq_R_bal_rect :
    (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ ->
    'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ ->
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> __
    -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __
    -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __
    -> __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ ->
    __ -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> __ -> __ -> __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ -> __ -> ('a1, 'a2) tree
    -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> __ -> __ -> 'a3)
    -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ ->
    __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __
    -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ ->
    'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ ->
    __ -> __ -> 'a3) -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_bal -> 'a3
  
  val coq_R_bal_rec :
    (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ ->
    'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ ->
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> __
    -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __
    -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __
    -> __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ ->
    __ -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> __ -> __ -> __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ -> __ -> ('a1, 'a2) tree
    -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> __ -> __ -> 'a3)
    -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ ->
    __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __
    -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ ->
    'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ ->
    __ -> __ -> 'a3) -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_bal -> 'a3
  
  val add :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_add =
  | R_add_0 of ('key, 'elt) tree
  | R_add_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_add_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree * ('key, 'elt) coq_R_add
  | R_add_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree * ('key, 'elt) coq_R_add
  
  val coq_R_add_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) tree -> __ -> 'a3) ->
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1,
    'a2) coq_R_add -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) tree
    -> ('a1, 'a2) coq_R_add -> 'a3
  
  val coq_R_add_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) tree -> __ -> 'a3) ->
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1,
    'a2) coq_R_add -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) tree
    -> ('a1, 'a2) coq_R_add -> 'a3
  
  val insert0 :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_insert0 =
  | R_insert0_0 of ('key, 'elt) tree
  | R_insert0_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_insert0_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_insert0
  | R_insert0_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_insert0
  
  val coq_R_insert0_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2)
    tree -> ('a1, 'a2) coq_R_insert0 -> 'a3 -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_insert0 -> 'a3 -> 'a3) -> ('a1, 'a2)
    tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_insert0 -> 'a3
  
  val coq_R_insert0_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2)
    tree -> ('a1, 'a2) coq_R_insert0 -> 'a3 -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_insert0 -> 'a3 -> 'a3) -> ('a1, 'a2)
    tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_insert0 -> 'a3
  
  val insert_aux :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree * bool
  
  val insert :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_insert_aux =
  | R_insert_aux_0 of ('key, 'elt) tree
  | R_insert_aux_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int
  | R_insert_aux_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * (('key, 'elt) tree * bool)
     * ('key, 'elt) coq_R_insert_aux * ('key, 'elt) tree * bool
  | R_insert_aux_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * (('key, 'elt) tree * bool)
     * ('key, 'elt) coq_R_insert_aux * ('key, 'elt) tree * bool
  | R_insert_aux_4 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * (('key, 'elt) tree * bool)
     * ('key, 'elt) coq_R_insert_aux * ('key, 'elt) tree * bool
  | R_insert_aux_5 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * (('key, 'elt) tree * bool)
     * ('key, 'elt) coq_R_insert_aux * ('key, 'elt) tree * bool
  
  val coq_R_insert_aux_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> (('a1, 'a2)
    tree * bool) -> ('a1, 'a2) coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree ->
    bool -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> (('a1, 'a2) tree * bool) ->
    ('a1, 'a2) coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __
    -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __ -> 'a3) ->
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __ -> 'a3) ->
    ('a1, 'a2) tree -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3
  
  val coq_R_insert_aux_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> (('a1, 'a2)
    tree * bool) -> ('a1, 'a2) coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree ->
    bool -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> (('a1, 'a2) tree * bool) ->
    ('a1, 'a2) coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __
    -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __ -> 'a3) ->
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __ -> 'a3) ->
    ('a1, 'a2) tree -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3
  
  val adjust :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) tree -> ('a1,
    'a2) tree
  
  type ('key, 'elt) coq_R_adjust =
  | R_adjust_0 of ('key, 'elt) tree
  | R_adjust_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_adjust_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_adjust
  | R_adjust_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_adjust
  
  val coq_R_adjust_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) tree -> __ ->
    'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2)
    tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2)
    tree -> ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_adjust -> 'a3
  
  val coq_R_adjust_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) tree -> __ ->
    'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2)
    tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2)
    tree -> ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_adjust -> 'a3
  
  val remove_min :
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2)
    tree * ('a1 * 'a2)
  
  type ('key, 'elt) coq_R_remove_min =
  | R_remove_min_0 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
  | R_remove_min_1 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * (('key, 'elt) tree * ('key * 'elt)) * ('key, 'elt) coq_R_remove_min
     * ('key, 'elt) tree * ('key * 'elt)
  
  val coq_R_remove_min_rect :
    (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> (('a1, 'a2) tree * ('a1 * 'a2)) ->
    ('a1, 'a2) coq_R_remove_min -> 'a3 -> ('a1, 'a2) tree -> ('a1 * 'a2) ->
    __ -> 'a3) -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> (('a1,
    'a2) tree * ('a1 * 'a2)) -> ('a1, 'a2) coq_R_remove_min -> 'a3
  
  val coq_R_remove_min_rec :
    (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> (('a1, 'a2) tree * ('a1 * 'a2)) ->
    ('a1, 'a2) coq_R_remove_min -> 'a3 -> ('a1, 'a2) tree -> ('a1 * 'a2) ->
    __ -> 'a3) -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> (('a1,
    'a2) tree * ('a1 * 'a2)) -> ('a1, 'a2) coq_R_remove_min -> 'a3
  
  val merge : ('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_merge =
  | R_merge_0 of ('key, 'elt) tree * ('key, 'elt) tree
  | R_merge_1 of ('key, 'elt) tree * ('key, 'elt) tree * ('key, 'elt) tree
     * 'key * 'elt * ('key, 'elt) tree * int
  | R_merge_2 of ('key, 'elt) tree * ('key, 'elt) tree * ('key, 'elt) tree
     * 'key * 'elt * ('key, 'elt) tree * int * ('key, 'elt) tree * 'key
     * 'elt * ('key, 'elt) tree * int * ('key, 'elt) tree * ('key * 'elt)
     * 'key * 'elt
  
  val coq_R_merge_rect :
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> __ -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a2) tree ->
    ('a1 * 'a2) -> __ -> 'a1 -> 'a2 -> __ -> 'a3) -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_merge -> 'a3
  
  val coq_R_merge_rec :
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> __ -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a2) tree ->
    ('a1 * 'a2) -> __ -> 'a1 -> 'a2 -> __ -> 'a3) -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_merge -> 'a3
  
  val remove :
    'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_remove =
  | R_remove_0 of ('key, 'elt) tree
  | R_remove_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_remove_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_remove
  | R_remove_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_remove
  
  val coq_R_remove_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1, 'a2)
    coq_R_remove -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1
    -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1,
    'a2) coq_R_remove -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_remove -> 'a3
  
  val coq_R_remove_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1, 'a2)
    coq_R_remove -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1
    -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1,
    'a2) coq_R_remove -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_remove -> 'a3
  
  val join :
    'a1 coq_OrderedType -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree
    -> ('a1, 'a2) tree
  
  type ('key, 'elt) triple = { t_left : ('key, 'elt) tree;
                               t_opt : 'elt option;
                               t_right : ('key, 'elt) tree }
  
  val triple_rect :
    (('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree -> 'a3) -> ('a1, 'a2)
    triple -> 'a3
  
  val triple_rec :
    (('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree -> 'a3) -> ('a1, 'a2)
    triple -> 'a3
  
  val t_left : ('a1, 'a2) triple -> ('a1, 'a2) tree
  
  val t_opt : ('a1, 'a2) triple -> 'a2 option
  
  val t_right : ('a1, 'a2) triple -> ('a1, 'a2) tree
  
  val split :
    'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) tree -> ('a1, 'a2) triple
  
  type ('key, 'elt) coq_R_split =
  | R_split_0 of ('key, 'elt) tree
  | R_split_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_split_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) triple
     * ('key, 'elt) coq_R_split * ('key, 'elt) tree * 'elt option
     * ('key, 'elt) tree
  | R_split_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) triple
     * ('key, 'elt) coq_R_split * ('key, 'elt) tree * 'elt option
     * ('key, 'elt) tree
  
  val coq_R_split_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3 -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3 -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree ->
    __ -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3
  
  val coq_R_split_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3 -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3 -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree ->
    __ -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3
  
  val concat :
    'a1 coq_OrderedType -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2)
    tree
  
  type ('key, 'elt) coq_R_concat =
  | R_concat_0 of ('key, 'elt) tree * ('key, 'elt) tree
  | R_concat_1 of ('key, 'elt) tree * ('key, 'elt) tree * ('key, 'elt) tree
     * 'key * 'elt * ('key, 'elt) tree * int
  | R_concat_2 of ('key, 'elt) tree * ('key, 'elt) tree * ('key, 'elt) tree
     * 'key * 'elt * ('key, 'elt) tree * int * ('key, 'elt) tree * 'key
     * 'elt * ('key, 'elt) tree * int * ('key, 'elt) tree * ('key * 'elt)
  
  val coq_R_concat_rect :
    'a1 coq_OrderedType -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> __ -> 'a3)
    -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2
    -> ('a1, 'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> ('a1, 'a2) tree -> ('a1 * 'a2) -> __ -> 'a3) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_concat -> 'a3
  
  val coq_R_concat_rec :
    'a1 coq_OrderedType -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> __ -> 'a3)
    -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2
    -> ('a1, 'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> ('a1, 'a2) tree -> ('a1 * 'a2) -> __ -> 'a3) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_concat -> 'a3
  
  val elements_aux : ('a1 * 'a2) list -> ('a1, 'a2) tree -> ('a1 * 'a2) list
  
  val elements : ('a1, 'a2) tree -> ('a1 * 'a2) list
  
  val fold : ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> 'a3 -> 'a3
  
  type ('key, 'elt) enumeration =
  | End
  | More of 'key * 'elt * ('key, 'elt) tree * ('key, 'elt) enumeration
  
  val enumeration_rect :
    'a3 -> ('a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) enumeration -> 'a3 ->
    'a3) -> ('a1, 'a2) enumeration -> 'a3
  
  val enumeration_rec :
    'a3 -> ('a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) enumeration -> 'a3 ->
    'a3) -> ('a1, 'a2) enumeration -> 'a3
  
  val cons :
    ('a1, 'a2) tree -> ('a1, 'a2) enumeration -> ('a1, 'a2) enumeration
  
  val equal_more :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> 'a1 -> 'a2 -> (('a1, 'a2)
    enumeration -> bool) -> ('a1, 'a2) enumeration -> bool
  
  val equal_cont :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) tree -> (('a1,
    'a2) enumeration -> bool) -> ('a1, 'a2) enumeration -> bool
  
  val equal_end : ('a1, 'a2) enumeration -> bool
  
  val equal :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> bool
  
  val map : ('a2 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a3) tree
  
  val mapi : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a3) tree
  
  val map_option :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option) -> ('a1, 'a2) tree ->
    ('a1, 'a3) tree
  
  val map2_opt :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option -> 'a4 option) -> (('a1,
    'a2) tree -> ('a1, 'a4) tree) -> (('a1, 'a3) tree -> ('a1, 'a4) tree) ->
    ('a1, 'a2) tree -> ('a1, 'a3) tree -> ('a1, 'a4) tree
  
  type ('key, 'elt, 'elt') coq_R_map_option =
  | R_map_option_0 of ('key, 'elt) tree
  | R_map_option_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * 'elt' * ('key, 'elt') tree
     * ('key, 'elt, 'elt') coq_R_map_option * ('key, 'elt') tree
     * ('key, 'elt, 'elt') coq_R_map_option
  | R_map_option_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * ('key, 'elt') tree
     * ('key, 'elt, 'elt') coq_R_map_option * ('key, 'elt') tree
     * ('key, 'elt, 'elt') coq_R_map_option
  
  val coq_R_map_option_rect :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option) -> (('a1, 'a2) tree ->
    __ -> 'a4) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> 'a3 -> __ -> ('a1, 'a3) tree -> ('a1, 'a2, 'a3)
    coq_R_map_option -> 'a4 -> ('a1, 'a3) tree -> ('a1, 'a2, 'a3)
    coq_R_map_option -> 'a4 -> 'a4) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a3) tree ->
    ('a1, 'a2, 'a3) coq_R_map_option -> 'a4 -> ('a1, 'a3) tree -> ('a1, 'a2,
    'a3) coq_R_map_option -> 'a4 -> 'a4) -> ('a1, 'a2) tree -> ('a1, 'a3)
    tree -> ('a1, 'a2, 'a3) coq_R_map_option -> 'a4
  
  val coq_R_map_option_rec :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option) -> (('a1, 'a2) tree ->
    __ -> 'a4) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> 'a3 -> __ -> ('a1, 'a3) tree -> ('a1, 'a2, 'a3)
    coq_R_map_option -> 'a4 -> ('a1, 'a3) tree -> ('a1, 'a2, 'a3)
    coq_R_map_option -> 'a4 -> 'a4) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a3) tree ->
    ('a1, 'a2, 'a3) coq_R_map_option -> 'a4 -> ('a1, 'a3) tree -> ('a1, 'a2,
    'a3) coq_R_map_option -> 'a4 -> 'a4) -> ('a1, 'a2) tree -> ('a1, 'a3)
    tree -> ('a1, 'a2, 'a3) coq_R_map_option -> 'a4
  
  type ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt =
  | R_map2_opt_0 of ('key, 'elt) tree * ('key, 'elt') tree
  | R_map2_opt_1 of ('key, 'elt) tree * ('key, 'elt') tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_map2_opt_2 of ('key, 'elt) tree * ('key, 'elt') tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * ('key, 'elt') tree * 'key * 'elt' * ('key, 'elt') tree * int
     * ('key, 'elt') tree * 'elt' option * ('key, 'elt') tree * 'elt''
     * ('key, 'elt'') tree * ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt
     * ('key, 'elt'') tree * ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt
  | R_map2_opt_3 of ('key, 'elt) tree * ('key, 'elt') tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * ('key, 'elt') tree * 'key * 'elt' * ('key, 'elt') tree * int
     * ('key, 'elt') tree * 'elt' option * ('key, 'elt') tree
     * ('key, 'elt'') tree * ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt
     * ('key, 'elt'') tree * ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt
  
  val coq_R_map2_opt_rect :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option -> 'a4 option) -> (('a1,
    'a2) tree -> ('a1, 'a4) tree) -> (('a1, 'a3) tree -> ('a1, 'a4) tree) ->
    (('a1, 'a2) tree -> ('a1, 'a3) tree -> __ -> 'a5) -> (('a1, 'a2) tree ->
    ('a1, 'a3) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a5) -> (('a1, 'a2) tree -> ('a1, 'a3) tree -> ('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a3)
    tree -> 'a1 -> 'a3 -> ('a1, 'a3) tree -> int -> __ -> ('a1, 'a3) tree ->
    'a3 option -> ('a1, 'a3) tree -> __ -> 'a4 -> __ -> ('a1, 'a4) tree ->
    ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> ('a1, 'a4) tree -> ('a1,
    'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> 'a5) -> (('a1, 'a2) tree -> ('a1,
    'a3) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> ('a1, 'a3) tree -> 'a1 -> 'a3 -> ('a1, 'a3) tree -> int -> __ ->
    ('a1, 'a3) tree -> 'a3 option -> ('a1, 'a3) tree -> __ -> __ -> ('a1,
    'a4) tree -> ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> ('a1, 'a4)
    tree -> ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> 'a5) -> ('a1, 'a2)
    tree -> ('a1, 'a3) tree -> ('a1, 'a4) tree -> ('a1, 'a2, 'a3, 'a4)
    coq_R_map2_opt -> 'a5
  
  val coq_R_map2_opt_rec :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option -> 'a4 option) -> (('a1,
    'a2) tree -> ('a1, 'a4) tree) -> (('a1, 'a3) tree -> ('a1, 'a4) tree) ->
    (('a1, 'a2) tree -> ('a1, 'a3) tree -> __ -> 'a5) -> (('a1, 'a2) tree ->
    ('a1, 'a3) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a5) -> (('a1, 'a2) tree -> ('a1, 'a3) tree -> ('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a3)
    tree -> 'a1 -> 'a3 -> ('a1, 'a3) tree -> int -> __ -> ('a1, 'a3) tree ->
    'a3 option -> ('a1, 'a3) tree -> __ -> 'a4 -> __ -> ('a1, 'a4) tree ->
    ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> ('a1, 'a4) tree -> ('a1,
    'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> 'a5) -> (('a1, 'a2) tree -> ('a1,
    'a3) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> ('a1, 'a3) tree -> 'a1 -> 'a3 -> ('a1, 'a3) tree -> int -> __ ->
    ('a1, 'a3) tree -> 'a3 option -> ('a1, 'a3) tree -> __ -> __ -> ('a1,
    'a4) tree -> ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> ('a1, 'a4)
    tree -> ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> 'a5) -> ('a1, 'a2)
    tree -> ('a1, 'a3) tree -> ('a1, 'a4) tree -> ('a1, 'a2, 'a3, 'a4)
    coq_R_map2_opt -> 'a5
  
  val map2 :
    'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) -> ('a1,
    'a2) tree -> ('a1, 'a3) tree -> ('a1, 'a4) tree
  
  module Proofs : 
   sig 
    module PX : 
     sig 
      
     end
    
    module L : 
     sig 
      type ('key, 'elt) dict = ('key * 'elt) list
      
      val empty : 'a1 coq_OrderedType -> ('a1, 'a2) dict
      
      val is_empty : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> bool
      
      val mem : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> bool
      
      type ('key, 'elt) coq_R_mem =
      | R_mem_0 of ('key, 'elt) dict
      | R_mem_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_mem_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_mem_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * bool * ('key, 'elt) coq_R_mem
      
      val coq_R_mem_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3 -> 'a3) -> ('a1, 'a2)
        dict -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
      
      val coq_R_mem_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3 -> 'a3) -> ('a1, 'a2)
        dict -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
      
      val mem_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val mem_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_mem_correct :
        'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> bool -> ('a1, 'a2)
        coq_R_mem
      
      val find : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> 'a2 option
      
      type ('key, 'elt) coq_R_find =
      | R_find_0 of ('key, 'elt) dict
      | R_find_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_find_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_find_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * 'elt option * ('key, 'elt) coq_R_find
      
      val coq_R_find_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3 -> 'a3) ->
        ('a1, 'a2) dict -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3
      
      val coq_R_find_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3 -> 'a3) ->
        ('a1, 'a2) dict -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3
      
      val find_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val find_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_find_correct :
        'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> 'a2 option -> ('a1,
        'a2) coq_R_find
      
      val add :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) dict -> ('a1, 'a2)
        dict
      
      type ('key, 'elt) coq_R_add =
      | R_add_0 of ('key, 'elt) dict
      | R_add_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_add_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_add_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * ('key, 'elt) dict * ('key, 'elt) coq_R_add
      
      val coq_R_add_rect :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3)
        -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) ->
        ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3
      
      val coq_R_add_rec :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3)
        -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) ->
        ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3
      
      val add_rect :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3)
        -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val add_rec :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3)
        -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_add_correct :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) dict -> ('a1, 'a2)
        dict -> ('a1, 'a2) coq_R_add
      
      val remove :
        'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> ('a1, 'a2) dict
      
      type ('key, 'elt) coq_R_remove =
      | R_remove_0 of ('key, 'elt) dict
      | R_remove_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_remove_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_remove_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * ('key, 'elt) dict * ('key, 'elt) coq_R_remove
      
      val coq_R_remove_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3 -> 'a3)
        -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove ->
        'a3
      
      val coq_R_remove_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3 -> 'a3)
        -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove ->
        'a3
      
      val remove_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val remove_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_remove_correct :
        'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> ('a1, 'a2) dict ->
        ('a1, 'a2) coq_R_remove
      
      val insert :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) dict
        -> ('a1, 'a2) dict
      
      type ('key, 'elt) coq_R_insert =
      | R_insert_0 of ('key, 'elt) dict
      | R_insert_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_insert_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_insert_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * ('key, 'elt) dict * ('key, 'elt) coq_R_insert
      
      val coq_R_insert_rect :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2)
        coq_R_insert -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict ->
        ('a1, 'a2) coq_R_insert -> 'a3
      
      val coq_R_insert_rec :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2)
        coq_R_insert -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict ->
        ('a1, 'a2) coq_R_insert -> 'a3
      
      val insert_rect :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val insert_rec :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_insert_correct :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) dict
        -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert
      
      val adjust :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) dict ->
        ('a1, 'a2) dict
      
      type ('key, 'elt) coq_R_adjust =
      | R_adjust_0 of ('key, 'elt) dict
      | R_adjust_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_adjust_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_adjust_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * ('key, 'elt) dict * ('key, 'elt) coq_R_adjust
      
      val coq_R_adjust_rect :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __
        -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3
        -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2)
        coq_R_adjust -> 'a3
      
      val coq_R_adjust_rec :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __
        -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3
        -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2)
        coq_R_adjust -> 'a3
      
      val adjust_rect :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __
        -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val adjust_rec :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __
        -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_adjust_correct :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) dict ->
        ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust
      
      val elements :
        'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1, 'a2) dict
      
      val cardinal : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> int
      
      val choose :
        'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1 * 'a2) option
      
      val fold :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) dict
        -> 'a3 -> 'a3
      
      type ('key, 'elt, 'a) coq_R_fold =
      | R_fold_0 of ('key, 'elt) dict * 'a
      | R_fold_1 of ('key, 'elt) dict * 'a * 'key * 'elt * ('key * 'elt) list
         * 'a * ('key, 'elt, 'a) coq_R_fold
      
      val coq_R_fold_rect :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4 ->
        'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold
        -> 'a4
      
      val coq_R_fold_rec :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4 ->
        'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold
        -> 'a4
      
      val fold_rect :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> 'a4 -> 'a4) -> ('a1, 'a2) dict -> 'a3 ->
        'a4
      
      val fold_rec :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> 'a4 -> 'a4) -> ('a1, 'a2) dict -> 'a3 ->
        'a4
      
      val coq_R_fold_correct :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) dict
        -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold
      
      val equal :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) dict ->
        ('a1, 'a2) dict -> bool
      
      type ('key, 'elt) coq_R_equal =
      | R_equal_0 of ('key, 'elt) dict * ('key, 'elt) dict
      | R_equal_1 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
         * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list * bool
         * ('key, 'elt) coq_R_equal
      | R_equal_2 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
         * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list
      | R_equal_3 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
         * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list * comparison
      | R_equal_4 of ('key, 'elt) dict * ('key, 'elt) dict
         * ('key, 'elt) dict * ('key, 'elt) dict
      
      val coq_R_equal_rect :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
        ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
        dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> __ -> bool -> ('a1, 'a2) coq_R_equal
        -> 'a3 -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2
        -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2
        -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        comparison -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict
        -> ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict -> __ -> __ -> 'a3) ->
        ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool -> ('a1, 'a2) coq_R_equal
        -> 'a3
      
      val coq_R_equal_rec :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
        ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
        dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> __ -> bool -> ('a1, 'a2) coq_R_equal
        -> 'a3 -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2
        -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2
        -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        comparison -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict
        -> ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict -> __ -> __ -> 'a3) ->
        ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool -> ('a1, 'a2) coq_R_equal
        -> 'a3
      
      val equal_rect :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
        ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
        dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
        'a2 -> ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) dict
        -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
        'a2 -> ('a1 * 'a2) list -> __ -> comparison -> __ -> __ -> 'a3) ->
        (('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> ('a1,
        'a2) dict -> __ -> __ -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict
        -> 'a3
      
      val equal_rec :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
        ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
        dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
        'a2 -> ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) dict
        -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
        'a2 -> ('a1 * 'a2) list -> __ -> comparison -> __ -> __ -> 'a3) ->
        (('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> ('a1,
        'a2) dict -> __ -> __ -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict
        -> 'a3
      
      val coq_R_equal_correct :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) dict ->
        ('a1, 'a2) dict -> bool -> ('a1, 'a2) coq_R_equal
      
      val map :
        'a1 coq_OrderedType -> ('a2 -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a3)
        dict
      
      val mapi :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) dict ->
        ('a1, 'a3) dict
      
      val option_cons :
        'a1 -> 'a2 option -> ('a1 * 'a2) list -> ('a1 * 'a2) list
      
      val map2_l :
        'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
        ('a1, 'a2) dict -> ('a1, 'a4) dict
      
      val map2_r :
        'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
        ('a1, 'a3) dict -> ('a1, 'a4) dict
      
      val map2 :
        'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
        ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1, 'a4) dict
      
      val map_OrderedType :
        'a1 coq_OrderedType -> ('a1, 'a2) dict coq_OrderedType
      
      module K : 
       sig 
        
       end
      
      val combine :
        'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1,
        'a2 option * 'a3 option) dict
      
      val fold_right_pair :
        ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3
      
      val map2_alt :
        'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
        ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1 * 'a4) list
      
      val at_least_one :
        'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option
      
      val at_least_one_then_f :
        ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2 option
        -> 'a3 option
     end
    
    val fold' :
      'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) tree ->
      'a3 -> 'a3
    
    val flatten_e : ('a1, 'a2) enumeration -> ('a1 * 'a2) list
   end
 end

module Raw : 
 sig 
  type ('key, 'elt) tree = ('key, 'elt) MapAVL.tree =
  | Leaf
  | Node of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  
  val tree_rect :
    'a3 -> (('a1, 'a2) tree -> 'a3 -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> 'a3 ->
    int -> 'a3) -> ('a1, 'a2) tree -> 'a3
  
  val tree_rec :
    'a3 -> (('a1, 'a2) tree -> 'a3 -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> 'a3 ->
    int -> 'a3) -> ('a1, 'a2) tree -> 'a3
  
  val height : ('a1, 'a2) tree -> int
  
  val cardinal : ('a1, 'a2) tree -> int
  
  val empty : ('a1, 'a2) tree
  
  val is_empty : ('a1, 'a2) tree -> bool
  
  val mem : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) tree -> bool
  
  type ('key, 'elt) coq_R_mem =
  | R_mem_0 of ('key, 'elt) tree
  | R_mem_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_mem_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * bool * ('key, 'elt) coq_R_mem
  | R_mem_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * bool * ('key, 'elt) coq_R_mem
  
  val coq_R_mem_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
    -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3 ->
    'a3) -> ('a1, 'a2) tree -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
  
  val coq_R_mem_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
    -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3 ->
    'a3) -> ('a1, 'a2) tree -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
  
  val find : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) tree -> 'a2 option
  
  type ('key, 'elt) coq_R_find =
  | R_find_0 of ('key, 'elt) tree
  | R_find_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_find_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * 'elt option * ('key, 'elt) coq_R_find
  | R_find_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * 'elt option * ('key, 'elt) coq_R_find
  
  val coq_R_find_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3
  
  val coq_R_find_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) coq_R_find
    -> 'a3
  
  val create :
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  val assert_false :
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  val bal :
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_bal =
  | R_bal_0 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
  | R_bal_1 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_2 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_3 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_4 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
  | R_bal_5 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_6 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_7 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_bal_8 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
  
  val coq_R_bal_rect :
    (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ ->
    'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ ->
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> __
    -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __
    -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __
    -> __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ ->
    __ -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> __ -> __ -> __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ -> __ -> ('a1, 'a2) tree
    -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> __ -> __ -> 'a3)
    -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ ->
    __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __
    -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ ->
    'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ ->
    __ -> __ -> 'a3) -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_bal -> 'a3
  
  val coq_R_bal_rec :
    (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ ->
    'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ ->
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> __
    -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __
    -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __
    -> __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ ->
    __ -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> __ -> __ -> __ -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ -> __ -> ('a1, 'a2) tree
    -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> __ -> __ -> 'a3)
    -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ -> __ ->
    __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __
    -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ ->
    'a3) -> (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> __ ->
    __ -> __ -> 'a3) -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_bal -> 'a3
  
  val add :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_add =
  | R_add_0 of ('key, 'elt) tree
  | R_add_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_add_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree * ('key, 'elt) coq_R_add
  | R_add_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree * ('key, 'elt) coq_R_add
  
  val coq_R_add_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) tree -> __ -> 'a3) ->
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1,
    'a2) coq_R_add -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) tree
    -> ('a1, 'a2) coq_R_add -> 'a3
  
  val coq_R_add_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) tree -> __ -> 'a3) ->
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1,
    'a2) coq_R_add -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) tree
    -> ('a1, 'a2) coq_R_add -> 'a3
  
  val insert0 :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_insert0 =
  | R_insert0_0 of ('key, 'elt) tree
  | R_insert0_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_insert0_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_insert0
  | R_insert0_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_insert0
  
  val coq_R_insert0_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2)
    tree -> ('a1, 'a2) coq_R_insert0 -> 'a3 -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_insert0 -> 'a3 -> 'a3) -> ('a1, 'a2)
    tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_insert0 -> 'a3
  
  val coq_R_insert0_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2)
    tree -> ('a1, 'a2) coq_R_insert0 -> 'a3 -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_insert0 -> 'a3 -> 'a3) -> ('a1, 'a2)
    tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_insert0 -> 'a3
  
  val insert_aux :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree * bool
  
  val insert :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_insert_aux =
  | R_insert_aux_0 of ('key, 'elt) tree
  | R_insert_aux_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int
  | R_insert_aux_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * (('key, 'elt) tree * bool)
     * ('key, 'elt) coq_R_insert_aux * ('key, 'elt) tree * bool
  | R_insert_aux_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * (('key, 'elt) tree * bool)
     * ('key, 'elt) coq_R_insert_aux * ('key, 'elt) tree * bool
  | R_insert_aux_4 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * (('key, 'elt) tree * bool)
     * ('key, 'elt) coq_R_insert_aux * ('key, 'elt) tree * bool
  | R_insert_aux_5 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * (('key, 'elt) tree * bool)
     * ('key, 'elt) coq_R_insert_aux * ('key, 'elt) tree * bool
  
  val coq_R_insert_aux_rect :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> (('a1, 'a2)
    tree * bool) -> ('a1, 'a2) coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree ->
    bool -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> (('a1, 'a2) tree * bool) ->
    ('a1, 'a2) coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __
    -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __ -> 'a3) ->
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __ -> 'a3) ->
    ('a1, 'a2) tree -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3
  
  val coq_R_insert_aux_rec :
    'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> (('a1, 'a2)
    tree * bool) -> ('a1, 'a2) coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree ->
    bool -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> (('a1, 'a2) tree * bool) ->
    ('a1, 'a2) coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __
    -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __ -> 'a3) ->
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3 -> ('a1, 'a2) tree -> bool -> __ -> __ -> 'a3) ->
    ('a1, 'a2) tree -> (('a1, 'a2) tree * bool) -> ('a1, 'a2)
    coq_R_insert_aux -> 'a3
  
  val adjust :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) tree -> ('a1,
    'a2) tree
  
  type ('key, 'elt) coq_R_adjust =
  | R_adjust_0 of ('key, 'elt) tree
  | R_adjust_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_adjust_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_adjust
  | R_adjust_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_adjust
  
  val coq_R_adjust_rect :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) tree -> __ ->
    'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2)
    tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2)
    tree -> ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_adjust -> 'a3
  
  val coq_R_adjust_rec :
    'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) tree -> __ ->
    'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2)
    tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2)
    tree -> ('a1, 'a2) coq_R_adjust -> 'a3 -> 'a3) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) coq_R_adjust -> 'a3
  
  val remove_min :
    ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2)
    tree * ('a1 * 'a2)
  
  type ('key, 'elt) coq_R_remove_min =
  | R_remove_min_0 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
  | R_remove_min_1 of ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * (('key, 'elt) tree * ('key * 'elt)) * ('key, 'elt) coq_R_remove_min
     * ('key, 'elt) tree * ('key * 'elt)
  
  val coq_R_remove_min_rect :
    (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> (('a1, 'a2) tree * ('a1 * 'a2)) ->
    ('a1, 'a2) coq_R_remove_min -> 'a3 -> ('a1, 'a2) tree -> ('a1 * 'a2) ->
    __ -> 'a3) -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> (('a1,
    'a2) tree * ('a1 * 'a2)) -> ('a1, 'a2) coq_R_remove_min -> 'a3
  
  val coq_R_remove_min_rec :
    (('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 ->
    'a2 -> ('a1, 'a2) tree -> int -> __ -> (('a1, 'a2) tree * ('a1 * 'a2)) ->
    ('a1, 'a2) coq_R_remove_min -> 'a3 -> ('a1, 'a2) tree -> ('a1 * 'a2) ->
    __ -> 'a3) -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> (('a1,
    'a2) tree * ('a1 * 'a2)) -> ('a1, 'a2) coq_R_remove_min -> 'a3
  
  val merge : ('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_merge =
  | R_merge_0 of ('key, 'elt) tree * ('key, 'elt) tree
  | R_merge_1 of ('key, 'elt) tree * ('key, 'elt) tree * ('key, 'elt) tree
     * 'key * 'elt * ('key, 'elt) tree * int
  | R_merge_2 of ('key, 'elt) tree * ('key, 'elt) tree * ('key, 'elt) tree
     * 'key * 'elt * ('key, 'elt) tree * int * ('key, 'elt) tree * 'key
     * 'elt * ('key, 'elt) tree * int * ('key, 'elt) tree * ('key * 'elt)
     * 'key * 'elt
  
  val coq_R_merge_rect :
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> __ -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a2) tree ->
    ('a1 * 'a2) -> __ -> 'a1 -> 'a2 -> __ -> 'a3) -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_merge -> 'a3
  
  val coq_R_merge_rec :
    (('a1, 'a2) tree -> ('a1, 'a2) tree -> __ -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a2)
    tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a2) tree ->
    ('a1 * 'a2) -> __ -> 'a1 -> 'a2 -> __ -> 'a3) -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_merge -> 'a3
  
  val remove :
    'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) tree -> ('a1, 'a2) tree
  
  type ('key, 'elt) coq_R_remove =
  | R_remove_0 of ('key, 'elt) tree
  | R_remove_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_remove_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_remove
  | R_remove_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) tree
     * ('key, 'elt) coq_R_remove
  
  val coq_R_remove_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1, 'a2)
    coq_R_remove -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1
    -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1,
    'a2) coq_R_remove -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_remove -> 'a3
  
  val coq_R_remove_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1, 'a2)
    coq_R_remove -> 'a3 -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1
    -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) tree -> ('a1,
    'a2) coq_R_remove -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) tree ->
    ('a1, 'a2) coq_R_remove -> 'a3
  
  val join :
    'a1 coq_OrderedType -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree
    -> ('a1, 'a2) tree
  
  type ('key, 'elt) triple = { t_left : ('key, 'elt) tree;
                               t_opt : 'elt option;
                               t_right : ('key, 'elt) tree }
  
  val triple_rect :
    (('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree -> 'a3) -> ('a1, 'a2)
    triple -> 'a3
  
  val triple_rec :
    (('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree -> 'a3) -> ('a1, 'a2)
    triple -> 'a3
  
  val t_left : ('a1, 'a2) triple -> ('a1, 'a2) tree
  
  val t_opt : ('a1, 'a2) triple -> 'a2 option
  
  val t_right : ('a1, 'a2) triple -> ('a1, 'a2) tree
  
  val split :
    'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) tree -> ('a1, 'a2) triple
  
  type ('key, 'elt) coq_R_split =
  | R_split_0 of ('key, 'elt) tree
  | R_split_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int
  | R_split_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) triple
     * ('key, 'elt) coq_R_split * ('key, 'elt) tree * 'elt option
     * ('key, 'elt) tree
  | R_split_3 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 'elt
     * ('key, 'elt) tree * int * ('key, 'elt) triple
     * ('key, 'elt) coq_R_split * ('key, 'elt) tree * 'elt option
     * ('key, 'elt) tree
  
  val coq_R_split_rect :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3 -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3 -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree ->
    __ -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3
  
  val coq_R_split_rec :
    'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) tree -> __ -> 'a3) -> (('a1,
    'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 ->
    ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3 -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree ->
    __ -> 'a3) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> __ -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3 -> ('a1, 'a2) tree -> 'a2 option -> ('a1, 'a2) tree ->
    __ -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a2) triple -> ('a1, 'a2)
    coq_R_split -> 'a3
  
  val concat :
    'a1 coq_OrderedType -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2)
    tree
  
  type ('key, 'elt) coq_R_concat =
  | R_concat_0 of ('key, 'elt) tree * ('key, 'elt) tree
  | R_concat_1 of ('key, 'elt) tree * ('key, 'elt) tree * ('key, 'elt) tree
     * 'key * 'elt * ('key, 'elt) tree * int
  | R_concat_2 of ('key, 'elt) tree * ('key, 'elt) tree * ('key, 'elt) tree
     * 'key * 'elt * ('key, 'elt) tree * int * ('key, 'elt) tree * 'key
     * 'elt * ('key, 'elt) tree * int * ('key, 'elt) tree * ('key * 'elt)
  
  val coq_R_concat_rect :
    'a1 coq_OrderedType -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> __ -> 'a3)
    -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2
    -> ('a1, 'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> ('a1, 'a2) tree -> ('a1 * 'a2) -> __ -> 'a3) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_concat -> 'a3
  
  val coq_R_concat_rec :
    'a1 coq_OrderedType -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> __ -> 'a3)
    -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2
    -> ('a1, 'a2) tree -> int -> __ -> __ -> 'a3) -> (('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> ('a1, 'a2) tree -> ('a1 * 'a2) -> __ -> 'a3) -> ('a1, 'a2) tree ->
    ('a1, 'a2) tree -> ('a1, 'a2) tree -> ('a1, 'a2) coq_R_concat -> 'a3
  
  val elements_aux : ('a1 * 'a2) list -> ('a1, 'a2) tree -> ('a1 * 'a2) list
  
  val elements : ('a1, 'a2) tree -> ('a1 * 'a2) list
  
  val fold : ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) tree -> 'a3 -> 'a3
  
  type ('key, 'elt) enumeration = ('key, 'elt) MapAVL.enumeration =
  | End
  | More of 'key * 'elt * ('key, 'elt) tree * ('key, 'elt) enumeration
  
  val enumeration_rect :
    'a3 -> ('a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) enumeration -> 'a3 ->
    'a3) -> ('a1, 'a2) enumeration -> 'a3
  
  val enumeration_rec :
    'a3 -> ('a1 -> 'a2 -> ('a1, 'a2) tree -> ('a1, 'a2) enumeration -> 'a3 ->
    'a3) -> ('a1, 'a2) enumeration -> 'a3
  
  val cons :
    ('a1, 'a2) tree -> ('a1, 'a2) enumeration -> ('a1, 'a2) enumeration
  
  val equal_more :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> 'a1 -> 'a2 -> (('a1, 'a2)
    enumeration -> bool) -> ('a1, 'a2) enumeration -> bool
  
  val equal_cont :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) tree -> (('a1,
    'a2) enumeration -> bool) -> ('a1, 'a2) enumeration -> bool
  
  val equal_end : ('a1, 'a2) enumeration -> bool
  
  val equal :
    'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) tree -> ('a1,
    'a2) tree -> bool
  
  val map : ('a2 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a3) tree
  
  val mapi : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) tree -> ('a1, 'a3) tree
  
  val map_option :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option) -> ('a1, 'a2) tree ->
    ('a1, 'a3) tree
  
  val map2_opt :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option -> 'a4 option) -> (('a1,
    'a2) tree -> ('a1, 'a4) tree) -> (('a1, 'a3) tree -> ('a1, 'a4) tree) ->
    ('a1, 'a2) tree -> ('a1, 'a3) tree -> ('a1, 'a4) tree
  
  type ('key, 'elt, 'elt') coq_R_map_option =
  | R_map_option_0 of ('key, 'elt) tree
  | R_map_option_1 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * 'elt' * ('key, 'elt') tree
     * ('key, 'elt, 'elt') coq_R_map_option * ('key, 'elt') tree
     * ('key, 'elt, 'elt') coq_R_map_option
  | R_map_option_2 of ('key, 'elt) tree * ('key, 'elt) tree * 'key * 
     'elt * ('key, 'elt) tree * int * ('key, 'elt') tree
     * ('key, 'elt, 'elt') coq_R_map_option * ('key, 'elt') tree
     * ('key, 'elt, 'elt') coq_R_map_option
  
  val coq_R_map_option_rect :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option) -> (('a1, 'a2) tree ->
    __ -> 'a4) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> 'a3 -> __ -> ('a1, 'a3) tree -> ('a1, 'a2, 'a3)
    coq_R_map_option -> 'a4 -> ('a1, 'a3) tree -> ('a1, 'a2, 'a3)
    coq_R_map_option -> 'a4 -> 'a4) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a3) tree ->
    ('a1, 'a2, 'a3) coq_R_map_option -> 'a4 -> ('a1, 'a3) tree -> ('a1, 'a2,
    'a3) coq_R_map_option -> 'a4 -> 'a4) -> ('a1, 'a2) tree -> ('a1, 'a3)
    tree -> ('a1, 'a2, 'a3) coq_R_map_option -> 'a4
  
  val coq_R_map_option_rec :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option) -> (('a1, 'a2) tree ->
    __ -> 'a4) -> (('a1, 'a2) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1,
    'a2) tree -> int -> __ -> 'a3 -> __ -> ('a1, 'a3) tree -> ('a1, 'a2, 'a3)
    coq_R_map_option -> 'a4 -> ('a1, 'a3) tree -> ('a1, 'a2, 'a3)
    coq_R_map_option -> 'a4 -> 'a4) -> (('a1, 'a2) tree -> ('a1, 'a2) tree ->
    'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> __ -> ('a1, 'a3) tree ->
    ('a1, 'a2, 'a3) coq_R_map_option -> 'a4 -> ('a1, 'a3) tree -> ('a1, 'a2,
    'a3) coq_R_map_option -> 'a4 -> 'a4) -> ('a1, 'a2) tree -> ('a1, 'a3)
    tree -> ('a1, 'a2, 'a3) coq_R_map_option -> 'a4
  
  type ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt =
  | R_map2_opt_0 of ('key, 'elt) tree * ('key, 'elt') tree
  | R_map2_opt_1 of ('key, 'elt) tree * ('key, 'elt') tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
  | R_map2_opt_2 of ('key, 'elt) tree * ('key, 'elt') tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * ('key, 'elt') tree * 'key * 'elt' * ('key, 'elt') tree * int
     * ('key, 'elt') tree * 'elt' option * ('key, 'elt') tree * 'elt''
     * ('key, 'elt'') tree * ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt
     * ('key, 'elt'') tree * ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt
  | R_map2_opt_3 of ('key, 'elt) tree * ('key, 'elt') tree
     * ('key, 'elt) tree * 'key * 'elt * ('key, 'elt) tree * int
     * ('key, 'elt') tree * 'key * 'elt' * ('key, 'elt') tree * int
     * ('key, 'elt') tree * 'elt' option * ('key, 'elt') tree
     * ('key, 'elt'') tree * ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt
     * ('key, 'elt'') tree * ('key, 'elt, 'elt', 'elt'') coq_R_map2_opt
  
  val coq_R_map2_opt_rect :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option -> 'a4 option) -> (('a1,
    'a2) tree -> ('a1, 'a4) tree) -> (('a1, 'a3) tree -> ('a1, 'a4) tree) ->
    (('a1, 'a2) tree -> ('a1, 'a3) tree -> __ -> 'a5) -> (('a1, 'a2) tree ->
    ('a1, 'a3) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a5) -> (('a1, 'a2) tree -> ('a1, 'a3) tree -> ('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a3)
    tree -> 'a1 -> 'a3 -> ('a1, 'a3) tree -> int -> __ -> ('a1, 'a3) tree ->
    'a3 option -> ('a1, 'a3) tree -> __ -> 'a4 -> __ -> ('a1, 'a4) tree ->
    ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> ('a1, 'a4) tree -> ('a1,
    'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> 'a5) -> (('a1, 'a2) tree -> ('a1,
    'a3) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> ('a1, 'a3) tree -> 'a1 -> 'a3 -> ('a1, 'a3) tree -> int -> __ ->
    ('a1, 'a3) tree -> 'a3 option -> ('a1, 'a3) tree -> __ -> __ -> ('a1,
    'a4) tree -> ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> ('a1, 'a4)
    tree -> ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> 'a5) -> ('a1, 'a2)
    tree -> ('a1, 'a3) tree -> ('a1, 'a4) tree -> ('a1, 'a2, 'a3, 'a4)
    coq_R_map2_opt -> 'a5
  
  val coq_R_map2_opt_rec :
    'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 option -> 'a4 option) -> (('a1,
    'a2) tree -> ('a1, 'a4) tree) -> (('a1, 'a3) tree -> ('a1, 'a4) tree) ->
    (('a1, 'a2) tree -> ('a1, 'a3) tree -> __ -> 'a5) -> (('a1, 'a2) tree ->
    ('a1, 'a3) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree ->
    int -> __ -> __ -> 'a5) -> (('a1, 'a2) tree -> ('a1, 'a3) tree -> ('a1,
    'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int -> __ -> ('a1, 'a3)
    tree -> 'a1 -> 'a3 -> ('a1, 'a3) tree -> int -> __ -> ('a1, 'a3) tree ->
    'a3 option -> ('a1, 'a3) tree -> __ -> 'a4 -> __ -> ('a1, 'a4) tree ->
    ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> ('a1, 'a4) tree -> ('a1,
    'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> 'a5) -> (('a1, 'a2) tree -> ('a1,
    'a3) tree -> ('a1, 'a2) tree -> 'a1 -> 'a2 -> ('a1, 'a2) tree -> int ->
    __ -> ('a1, 'a3) tree -> 'a1 -> 'a3 -> ('a1, 'a3) tree -> int -> __ ->
    ('a1, 'a3) tree -> 'a3 option -> ('a1, 'a3) tree -> __ -> __ -> ('a1,
    'a4) tree -> ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> ('a1, 'a4)
    tree -> ('a1, 'a2, 'a3, 'a4) coq_R_map2_opt -> 'a5 -> 'a5) -> ('a1, 'a2)
    tree -> ('a1, 'a3) tree -> ('a1, 'a4) tree -> ('a1, 'a2, 'a3, 'a4)
    coq_R_map2_opt -> 'a5
  
  val map2 :
    'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) -> ('a1,
    'a2) tree -> ('a1, 'a3) tree -> ('a1, 'a4) tree
  
  module Proofs : 
   sig 
    module PX : 
     sig 
      
     end
    
    module L : 
     sig 
      type ('key, 'elt) dict = ('key * 'elt) list
      
      val empty : 'a1 coq_OrderedType -> ('a1, 'a2) dict
      
      val is_empty : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> bool
      
      val mem : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> bool
      
      type ('key, 'elt) coq_R_mem =
      | R_mem_0 of ('key, 'elt) dict
      | R_mem_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_mem_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_mem_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * bool * ('key, 'elt) coq_R_mem
      
      val coq_R_mem_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3 -> 'a3) -> ('a1, 'a2)
        dict -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
      
      val coq_R_mem_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> bool -> ('a1, 'a2) coq_R_mem -> 'a3 -> 'a3) -> ('a1, 'a2)
        dict -> bool -> ('a1, 'a2) coq_R_mem -> 'a3
      
      val mem_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val mem_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_mem_correct :
        'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> bool -> ('a1, 'a2)
        coq_R_mem
      
      val find : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> 'a2 option
      
      type ('key, 'elt) coq_R_find =
      | R_find_0 of ('key, 'elt) dict
      | R_find_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_find_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_find_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * 'elt option * ('key, 'elt) coq_R_find
      
      val coq_R_find_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3 -> 'a3) ->
        ('a1, 'a2) dict -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3
      
      val coq_R_find_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3 -> 'a3) ->
        ('a1, 'a2) dict -> 'a2 option -> ('a1, 'a2) coq_R_find -> 'a3
      
      val find_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val find_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_find_correct :
        'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> 'a2 option -> ('a1,
        'a2) coq_R_find
      
      val add :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) dict -> ('a1, 'a2)
        dict
      
      type ('key, 'elt) coq_R_add =
      | R_add_0 of ('key, 'elt) dict
      | R_add_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_add_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_add_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * ('key, 'elt) dict * ('key, 'elt) coq_R_add
      
      val coq_R_add_rect :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3)
        -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) ->
        ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3
      
      val coq_R_add_rec :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3)
        -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3 -> 'a3) ->
        ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_add -> 'a3
      
      val add_rect :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3)
        -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val add_rec :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2) dict -> __ -> 'a3)
        -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_add_correct :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) dict -> ('a1, 'a2)
        dict -> ('a1, 'a2) coq_R_add
      
      val remove :
        'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> ('a1, 'a2) dict
      
      type ('key, 'elt) coq_R_remove =
      | R_remove_0 of ('key, 'elt) dict
      | R_remove_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_remove_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_remove_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * ('key, 'elt) dict * ('key, 'elt) coq_R_remove
      
      val coq_R_remove_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3 -> 'a3)
        -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove ->
        'a3
      
      val coq_R_remove_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove -> 'a3 -> 'a3)
        -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_remove ->
        'a3
      
      val remove_rect :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val remove_rec :
        'a1 coq_OrderedType -> 'a1 -> (('a1, 'a2) dict -> __ -> 'a3) ->
        (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> __ ->
        'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list ->
        __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_remove_correct :
        'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) dict -> ('a1, 'a2) dict ->
        ('a1, 'a2) coq_R_remove
      
      val insert :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) dict
        -> ('a1, 'a2) dict
      
      type ('key, 'elt) coq_R_insert =
      | R_insert_0 of ('key, 'elt) dict
      | R_insert_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_insert_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_insert_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * ('key, 'elt) dict * ('key, 'elt) coq_R_insert
      
      val coq_R_insert_rect :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2)
        coq_R_insert -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict ->
        ('a1, 'a2) coq_R_insert -> 'a3
      
      val coq_R_insert_rec :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2)
        coq_R_insert -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict ->
        ('a1, 'a2) coq_R_insert -> 'a3
      
      val insert_rect :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val insert_rec :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> (('a1, 'a2) dict
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_insert_correct :
        'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) dict
        -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_insert
      
      val adjust :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) dict ->
        ('a1, 'a2) dict
      
      type ('key, 'elt) coq_R_adjust =
      | R_adjust_0 of ('key, 'elt) dict
      | R_adjust_1 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_adjust_2 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
      | R_adjust_3 of ('key, 'elt) dict * 'key * 'elt * ('key * 'elt) list
         * ('key, 'elt) dict * ('key, 'elt) coq_R_adjust
      
      val coq_R_adjust_rect :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __
        -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3
        -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2)
        coq_R_adjust -> 'a3
      
      val coq_R_adjust_rec :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __
        -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust -> 'a3
        -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2)
        coq_R_adjust -> 'a3
      
      val adjust_rect :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __
        -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val adjust_rec :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> (('a1, 'a2) dict -> __
        -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __
        -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list
        -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2)
        list -> __ -> __ -> 'a3 -> 'a3) -> ('a1, 'a2) dict -> 'a3
      
      val coq_R_adjust_correct :
        'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) dict ->
        ('a1, 'a2) dict -> ('a1, 'a2) coq_R_adjust
      
      val elements :
        'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1, 'a2) dict
      
      val cardinal : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> int
      
      val choose :
        'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1 * 'a2) option
      
      val fold :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) dict
        -> 'a3 -> 'a3
      
      type ('key, 'elt, 'a) coq_R_fold =
      | R_fold_0 of ('key, 'elt) dict * 'a
      | R_fold_1 of ('key, 'elt) dict * 'a * 'key * 'elt * ('key * 'elt) list
         * 'a * ('key, 'elt, 'a) coq_R_fold
      
      val coq_R_fold_rect :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4 ->
        'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold
        -> 'a4
      
      val coq_R_fold_rec :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold -> 'a4 ->
        'a4) -> ('a1, 'a2) dict -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold
        -> 'a4
      
      val fold_rect :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> 'a4 -> 'a4) -> ('a1, 'a2) dict -> 'a3 ->
        'a4
      
      val fold_rec :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> 'a3 -> __ -> 'a4) -> (('a1, 'a2) dict -> 'a3 -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> 'a4 -> 'a4) -> ('a1, 'a2) dict -> 'a3 ->
        'a4
      
      val coq_R_fold_correct :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) dict
        -> 'a3 -> 'a3 -> ('a1, 'a2, 'a3) coq_R_fold
      
      val equal :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) dict ->
        ('a1, 'a2) dict -> bool
      
      type ('key, 'elt) coq_R_equal =
      | R_equal_0 of ('key, 'elt) dict * ('key, 'elt) dict
      | R_equal_1 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
         * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list * bool
         * ('key, 'elt) coq_R_equal
      | R_equal_2 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
         * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list
      | R_equal_3 of ('key, 'elt) dict * ('key, 'elt) dict * 'key * 'elt
         * ('key * 'elt) list * 'key * 'elt * ('key * 'elt) list * comparison
      | R_equal_4 of ('key, 'elt) dict * ('key, 'elt) dict
         * ('key, 'elt) dict * ('key, 'elt) dict
      
      val coq_R_equal_rect :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
        ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
        dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> __ -> bool -> ('a1, 'a2) coq_R_equal
        -> 'a3 -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2
        -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2
        -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        comparison -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict
        -> ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict -> __ -> __ -> 'a3) ->
        ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool -> ('a1, 'a2) coq_R_equal
        -> 'a3
      
      val coq_R_equal_rec :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
        ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
        dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> __ -> bool -> ('a1, 'a2) coq_R_equal
        -> 'a3 -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2
        -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict -> 'a1 -> 'a2
        -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ ->
        comparison -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2) dict
        -> ('a1, 'a2) dict -> __ -> ('a1, 'a2) dict -> __ -> __ -> 'a3) ->
        ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool -> ('a1, 'a2) coq_R_equal
        -> 'a3
      
      val equal_rect :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
        ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
        dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
        'a2 -> ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) dict
        -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
        'a2 -> ('a1 * 'a2) list -> __ -> comparison -> __ -> __ -> 'a3) ->
        (('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> ('a1,
        'a2) dict -> __ -> __ -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict
        -> 'a3
      
      val equal_rec :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> (('a1, 'a2) dict ->
        ('a1, 'a2) dict -> __ -> __ -> 'a3) -> (('a1, 'a2) dict -> ('a1, 'a2)
        dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 -> 'a2 ->
        ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3 -> 'a3) -> (('a1, 'a2) dict
        -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
        'a2 -> ('a1 * 'a2) list -> __ -> __ -> __ -> 'a3) -> (('a1, 'a2) dict
        -> ('a1, 'a2) dict -> 'a1 -> 'a2 -> ('a1 * 'a2) list -> __ -> 'a1 ->
        'a2 -> ('a1 * 'a2) list -> __ -> comparison -> __ -> __ -> 'a3) ->
        (('a1, 'a2) dict -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> __ -> ('a1,
        'a2) dict -> __ -> __ -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a2) dict
        -> 'a3
      
      val coq_R_equal_correct :
        'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) dict ->
        ('a1, 'a2) dict -> bool -> ('a1, 'a2) coq_R_equal
      
      val map :
        'a1 coq_OrderedType -> ('a2 -> 'a3) -> ('a1, 'a2) dict -> ('a1, 'a3)
        dict
      
      val mapi :
        'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) dict ->
        ('a1, 'a3) dict
      
      val option_cons :
        'a1 -> 'a2 option -> ('a1 * 'a2) list -> ('a1 * 'a2) list
      
      val map2_l :
        'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
        ('a1, 'a2) dict -> ('a1, 'a4) dict
      
      val map2_r :
        'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
        ('a1, 'a3) dict -> ('a1, 'a4) dict
      
      val map2 :
        'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
        ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1, 'a4) dict
      
      val map_OrderedType :
        'a1 coq_OrderedType -> ('a1, 'a2) dict coq_OrderedType
      
      module K : 
       sig 
        
       end
      
      val combine :
        'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1,
        'a2 option * 'a3 option) dict
      
      val fold_right_pair :
        ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1 * 'a2) list -> 'a3 -> 'a3
      
      val map2_alt :
        'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) ->
        ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1 * 'a4) list
      
      val at_least_one :
        'a1 option -> 'a2 option -> ('a1 option * 'a2 option) option
      
      val at_least_one_then_f :
        ('a1 option -> 'a2 option -> 'a3 option) -> 'a1 option -> 'a2 option
        -> 'a3 option
     end
    
    val fold' :
      'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) tree ->
      'a3 -> 'a3
    
    val flatten_e : ('a1, 'a2) enumeration -> ('a1 * 'a2) list
   end
 end

type ('key, 'elt) dict =
  ('key, 'elt) Raw.tree
  (* singleton inductive, whose constructor was Bst *)

val this : 'a1 coq_OrderedType -> ('a1, 'a2) dict -> ('a1, 'a2) Raw.tree

type ('key, 'elt) t = ('key, 'elt) dict

val empty : 'a1 coq_OrderedType -> ('a1, 'a2) t

val is_empty : 'a1 coq_OrderedType -> ('a1, 'a2) t -> bool

val add : 'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a1, 'a2) t -> ('a1, 'a2) t

val insert :
  'a1 coq_OrderedType -> 'a1 -> 'a2 -> ('a2 -> 'a2) -> ('a1, 'a2) t -> ('a1,
  'a2) t

val adjust :
  'a1 coq_OrderedType -> 'a1 -> ('a2 -> 'a2) -> ('a1, 'a2) t -> ('a1, 'a2) t

val remove : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) t -> ('a1, 'a2) t

val mem : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) t -> bool

val find : 'a1 coq_OrderedType -> 'a1 -> ('a1, 'a2) t -> 'a2 option

val map : 'a1 coq_OrderedType -> ('a2 -> 'a3) -> ('a1, 'a2) t -> ('a1, 'a3) t

val mapi :
  'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) t -> ('a1, 'a3) t

val map2 :
  'a1 coq_OrderedType -> ('a2 option -> 'a3 option -> 'a4 option) -> ('a1,
  'a2) t -> ('a1, 'a3) t -> ('a1, 'a4) t

val elements : 'a1 coq_OrderedType -> ('a1, 'a2) t -> ('a1 * 'a2) list

val cardinal : 'a1 coq_OrderedType -> ('a1, 'a2) t -> int

val fold :
  'a1 coq_OrderedType -> ('a1 -> 'a2 -> 'a3 -> 'a3) -> ('a1, 'a2) t -> 'a3 ->
  'a3

val equal :
  'a1 coq_OrderedType -> ('a2 -> 'a2 -> bool) -> ('a1, 'a2) t -> ('a1, 'a2) t
  -> bool

val compare_more :
  'a1 coq_OrderedType -> 'a2 coq_OrderedType -> 'a1 -> 'a2 -> (('a1, 'a2)
  Raw.enumeration -> comparison) -> ('a1, 'a2) Raw.enumeration -> comparison

val compare_cont :
  'a1 coq_OrderedType -> 'a2 coq_OrderedType -> ('a1, 'a2) Raw.tree -> (('a1,
  'a2) Raw.enumeration -> comparison) -> ('a1, 'a2) Raw.enumeration ->
  comparison

val compare_end : ('a1, 'a2) Raw.enumeration -> comparison

val compare_pure :
  'a1 coq_OrderedType -> 'a2 coq_OrderedType -> ('a1, 'a2) Raw.tree -> ('a1,
  'a2) Raw.tree -> comparison

val map_OrderedType :
  'a1 coq_OrderedType -> 'a2 coq_OrderedType -> ('a1, 'a2) dict
  coq_OrderedType

